/*
 * Copyright (c) 2004 DMC Co., Ltd.
 *
 * Copyright (c) 1999  Machine Vision Holdings Incorporated
 * Author: Mayk Langer <langer@vsys.de>
 *
 * Template driver used: Copyright (c) 1998  Metro Link Incorporated
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, cpy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
 * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * Except as contained in this notice, the name of the Metro Link shall not be
 * used in advertising or otherwise to promote the sale, use or other dealings
 * in this Software without prior written authorization from Metro Link.
 *
 */
/* $XFree86: xc/programs/Xserver/hw/xfree86/input/dmc/xf86DMC.c,v 1.2 2001/11/26 16:25:52 dawes Exp $ */

//#define	_3MEX2				1
#define _DMC_C_

/* --> commnet out(#if 0) before fedora-core-5 */
/* XORG_NEWVERS0 = 1 :fedora-core-5/6(xorg release7.x) */
/* XORG_NEWVERS  = 1 :fedora-core-5/later(xorg release1.3) */
/* XORG_NEWVERS14 = 1 :fedora-core-9/later(xorg release1.4) */
/* XORG_NEWVERS110 = 1 :fedora-core-15/later(xorg release1.10) */
/* XORG_NEWVERV112 = 1 :fedora-core-17(xorg release1.12.0) */
/* CHG_SCR_RESOLUTION = 1 :fedora-core-5->8/12(for change screen resolution) */
/* ADJ_CALIB_DEFSCR = 1 :fedora-core-9->11 */
#if 1
#define	XORG_NEWVERS0		0
#define	XORG_NEWVERS		1
#define	XORG_NEWVERS14		1
#define	XORG_NEWVERS110		1
#define XORG_NEWVERV112		1
#define	CHG_SCR_RESOLUTION	0
#define ADJ_CALIB_DEFSCR	0
#else
/* --> fedora4 or previous version */
#define	CHG_SCR_RESOLUTION	1
#define	XORG_OLDVERS		1
#endif
/* <-- commnet out(#if 0) before fedora-core-5 */

#define DEBUG_DMC			0
#define DEBUG_APCMD			0
#define DEBUG_CMD			0
#define DEBUG_PROM			0
#define DEBUG_DISP_POINT	0
#define DEBUG_CALIB_AREA	0

#define CALIB_PAT_A			1
#define	EASY_CALIB			1
#define	LOG_PROM_RD			1
#define	LOG_PROM_WR			1
#define	EEPROM_EMPTY_CHECK	1

#if _3MEX2
#define	TP_MAX_X	1024
#define	TP_MAX_Y	1024
#endif

#ifdef XORG_NEWVERS
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#endif

#if XORG_NEWVERS0
#include <linux/types.h>
#endif

//#include <misc.h>
#ifndef XORG_NEWVERS
#include <Xos.h>
#endif
#include <xf86.h>
#if XORG_NEWVERS0
#define NEED_XF86_TYPES
#endif
#if XORG_NEWVERS14
# include <fcntl.h>
# include <xf86_OSlib.h>
# include <X11/keysym.h>
#else
# ifdef XORG_NEWVERS
#  if XORG_NEWVERS0
#   include <n_xf86_libc.h>
#  else
#   include <xf86_libc.h>
#  endif
# else
#  include <xf86_ansic.h>
# endif
#endif
#include <xf86_OSproc.h>
#include <xf86Xinput.h>
#include <xisb.h>
#include <exevents.h>

#include <sys/timeb.h>
#include "cmd.h"
#include "../vers.h"
#include "xf86DMC.h"
#if _3MEX2
#else
#include "../usb26/usbdmc.h"
#endif

#ifndef ENOTCONN
#define	ENOTCONN	107
#endif

#ifndef true
#define	true	1
#define	false	0
#endif

#ifndef XORG_NEWVERS
#define SYSCALL(call)	while(((call) == -1) && (errno == EINTR))
#endif

#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 7
#include <X11/Xatom.h>
#include <xserver-properties.h>
#endif

#define	MAXBUTTONS	3

#if 0
#ifndef u_char
typedef unsigned char u_char;
#endif
#ifndef u_short
typedef unsigned short u_short;
#endif
#ifndef u_int
typedef unsigned int u_int;
#endif
#endif

/* comm command */
#define	INI_2_IDLE		0x05
#define	S_RATE			0x40
#define	RESET			0x55
#define	IDLE_2_XYP		0x31
#define	XYP_2_IDLE		0x02
#define	IDLE_2_RomRd	0x1d
#define	IDEL_2_RomWr	0x0d
#define	ACK				0x06
#define	NAK				0x15

#if XORG_NEWVERS14
#define	CONS_BEEP_VAL (((1193190/880)&0xffff)|(((unsigned long)15*100/50)<<16))
#endif

static int asleep(DMCPrivatePtr priv,int sec);
static int ring_beep(DMCPrivatePtr priv);
BOOL adjust_xy(DMCPrivatePtr priv,int inx,int iny,int *x,int *y);

#if USE_PIPE_COMM
static int read_dmcpkt(DMCPrivatePtr priv,void *p,int size);
static int send_dmcpkt(DMCPrivatePtr priv,void *p,int size);
static int calib_cmd_exec(DMCPrivatePtr priv,dmc_pkt *pkt,InputInfoPtr pInfo);
static Bool calib_set(DMCPrivatePtr priv,dmc_pkt *pkt);
#else
static int calib_cmd_exec(DMCPrivatePtr priv,int mode,InputInfoPtr pInfo);
static Bool calib_set(DMCPrivatePtr priv,int type,unsigned char a);
#endif

static int set_calib_area(DMCPrivatePtr priv,BOOL use_temp);
static int set_temp_data(DMCPrivatePtr priv,int calib_point,int ofs,unsigned int a[][2]);
static int set_temp_data_on_rdfile(DMCPrivatePtr priv,int calib_point,int ofs,unsigned int a[][2]);
static void disp_calib_data(DMCPrivatePtr priv,char *s,unsigned int d[][4]);
static void caldif(u_int *d,u_int *a,u_int *b);
static void aaacpy(u_int *d,u_int *a,u_int *b);

static int tx_set_mem(DMCPrivatePtr priv,u_short addr,u_short dat);
static int tx_get_mem(DMCPrivatePtr priv,u_short addr);
static int tx_set_offdelay(DMCPrivatePtr priv,u_short dat);
static int tx_get_offdelay(DMCPrivatePtr priv);
static Bool specify_set(DMCPrivatePtr priv);
static Bool tx_reset_goto_init(DMCPrivatePtr priv,Bool wait_ack);
static Bool tx_specify_goto_idle(DMCPrivatePtr priv,Bool wait_ack);
static Bool tx_xyp_exit_goto_idle(DMCPrivatePtr priv,Bool wait_ack);
static Bool goto_rom_read(DMCPrivatePtr priv);
static Bool goto_xyp(DMCPrivatePtr priv);
static Bool exec_cmd_send(DMCPrivatePtr priv,u_char s[],int len,Bool wait_ack);
static Bool get_status(DMCPrivatePtr priv,char *s);
static Bool init_dev(DMCPrivatePtr priv,Bool reinit);
static Bool do_init_dev(DMCPrivatePtr priv,Bool reinit);
static int read_eeprom(DMCPrivatePtr priv);
static Bool write_eeprom(DMCPrivatePtr priv);
static void set_1_pkt_calib_dat(Pkt_Calib *p,u_int dat[]);
static void adj_pkt_calib_dat(Bool write_exec,void *top,int max_x,int max_y);
static void adj_1_pkt_calib_dat(u_short *st,int plus,u_short *ed
							,int def,u_short omax,u_short nmax);
static void cnv_lowhigh_calib_dat(Bool write_exec,void *top);
static void cnv_1_lowhigh_calib_dat(Pkt_Calib *p);
#define	CONV_LOWHIGH(a)	((a>>8)|(a<<8))

static Bool read_save_file(DMCPrivatePtr priv);
static Bool do_read_save_file(DMCPrivatePtr priv,DMCSaveFile *file_data);
static Bool write_save_file(DMCPrivatePtr priv,Bool no_calib);
static int get_cfg_calib_str(char *str,unsigned int *a,unsigned int *b);
static int StrCmp(char *s1,char *s2);
static void adj_read_save_file(DMCPrivatePtr priv);
static void adj_write_save_file(DMCPrivatePtr priv);
#if CHG_SCR_RESOLUTION
static void adj_chg_resolution(DMCPrivatePtr priv);
#endif
#if ADJ_CALIB_DEFSCR
static void adj_temp_data_on_defscr(DMCPrivatePtr priv);
#endif
#ifndef XORG_OLDVERS
void insmod(DMCPrivatePtr priv);
#endif

static NTIME get_time();
static int diff_time(NTIME t2,NTIME t1);

static void test(void);

InputDriverRec DMC = {
        1,
        "dmc",
        NULL,
        DMCPreInit,
        /*DMCUnInit*/NULL,
        NULL,
        0
};        


#ifdef XFree86LOADER

#if XORG_NEWVERS14
static XF86ModuleVersionInfo VersionRec =
{
	"dmc",
	MODULEVENDORSTRING,
	MODINFOSTRING1,
	MODINFOSTRING2,
	XORG_VERSION_CURRENT,
	PACKAGE_VERSION_MAJOR, PACKAGE_VERSION_MINOR, PACKAGE_VERSION_PATCHLEVEL,
	ABI_CLASS_XINPUT,
	ABI_XINPUT_VERSION,
	MOD_CLASS_XINPUT,
	{0, 0, 0, 0}				/* signature, to be patched into the file by
								 * a tool */
};
#else
static XF86ModuleVersionInfo VersionRec =
{
	"dmc",
	MODULEVENDORSTRING,
	MODINFOSTRING1,
	MODINFOSTRING2,
	XF86_VERSION_CURRENT,
	1, 0, 0,
	ABI_CLASS_XINPUT,
	ABI_XINPUT_VERSION,
	MOD_CLASS_XINPUT,
	{0, 0, 0, 0}				/* signature, to be patched into the file by
								 * a tool */
};
#endif


static const char *reqSymbols[] = 
{
	"AddEnabledDevice",
	"ErrorF",
	"InitButtonClassDeviceStruct",
	"InitProximityClassDeviceStruct",
	"InitValuatorAxisStruct",
	"InitValuatorClassDeviceStruct",
	"InitPtrFeedbackClassDeviceStruct",
	"RemoveEnabledDevice",
	"Xcalloc",
	"Xfree",
	"XisbBlockDuration",
	"XisbFree",
	"XisbNew",
	"XisbRead",
	"XisbTrace",
	"screenInfo",
	"xf86AddInputDriver",
	"xf86AllocateInput",
	"xf86CloseSerial",
	"xf86CollectInputOptions",
	"xf86ErrorFVerb",
	"xf86FindOptionValue",
	"xf86GetMotionEvents",
	"xf86GetVerbosity",
	"xf86MotionHistoryAllocate",
	"xf86NameCmp",
	"xf86OpenSerial",
	"xf86OptionListCreate",
	"xf86OptionListMerge",
	"xf86OptionListReport",
	"xf86PostButtonEvent",
	"xf86PostMotionEvent",
	"xf86PostProximityEvent",
	"xf86ProcessCommonOptions",
	"xf86ScaleAxis",
	"xf86SetIntOption",
	"xf86SetStrOption",
	"xf86XInputSetScreen",
#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) == 0
	"xf86XInputSetSendCoreEvents",
#endif
#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) < 3
	"xf86getsecs",
#endif
	NULL
};


static pointer DMCSetupProc(pointer module,pointer options,int *errmaj,int *errmin )
{
#if 1
	xf86Msg(X_WARNING, "DMC : SetupProc in\n");
#endif
#if 0
	xf86LoaderReqSymLists(reqSymbols, NULL);
#endif
	xf86AddInputDriver(&DMC, module, 0);
	return (pointer) 1;
}
#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 7
static void DMCUnsetupProc(pointer *p)
{
}
#endif

#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 7
_X_EXPORT XF86ModuleData dmcModuleData = { &VersionRec, DMCSetupProc, DMCUnsetupProc };
#else
XF86ModuleData dmcModuleData = { &VersionRec, DMCSetupProc, NULL };
#endif


#endif /* XFree86LOADER */


/* 
 * Be sure to set vmin appropriately for your device's protocol. You want to
 * read a full packet before returning
 */
static const char *default_options[] =
{
	/*	"Device", "/dev/ttyS1",*/
	"BaudRate", "9600",
	"StopBits", "1",
	"DataBits", "8",
	"Parity", "None",
	"Vmin", "3",
	"Vtime", "1",
	"FlowControl", "None",
	NULL,
};


/*
 * calibration config file
 */
#define	CFG_CALIB_DATA_FILE		"/etc/X11/dmc_calib.dat"
#define	CFG_CALIB_DATA_FILE2	"/etc/X11/dmc_calib2.dat"
#define	API_DIR					"/tmp"

static char *cfgetcstr[] =
{
	"PenDownBeep","PenUpBeep","SamplingRate","LiftofDelay",NULL
};
static char *cfgrawstr[] =
{
	"RawX0","RawY0","RawX1","RawY1","RawX2","RawY2","RawX3","RawY3","RawX4","RawY4",
	"RawX5","RawY5","RawX6","RawY6","RawX7","RawY7","RawX8","RawY8",NULL
};
static char *cfgcalstr[] =
{
	"CalX0","CalY0","CalX1","CalY1","CalX2","CalY2","CalX3","CalY3","CalX4","CalY4",
	"CalX5","CalY5","CalX6","CalY6","CalX7","CalY7","CalX8","CalY8",NULL
};

/*****************************************************************************
 *	Function Definitions
 ****************************************************************************/

#if XORG_NEWVERS110
static int DMCPreInit(InputDriverPtr drv, InputInfoPtr pInfo, int flags)
#else
static InputInfoPtr DMCPreInit(InputDriverPtr drv, IDevPtr dev, int flags)
#endif
{              
	int i;
#if !XORG_NEWVERS110
	InputInfoPtr pInfo;
#endif
   	DMCPrivatePtr priv = xcalloc (1, sizeof (DMCPrivateRec));
	char *s;

#if XORG_NEWVERS110
	if (!priv)
		return( 1 );
#else
	if (!priv)
		return NULL;
#endif

#if !XORG_NEWVERS110
	if (!(pInfo = xf86AllocateInput(drv, 0))) {
		xfree(priv);
		return NULL;
	}
#endif

	priv->usb_dev = 0;
	priv->min_x = 0;
	priv->max_x = 0;
	priv->min_y = 0;
	priv->max_y = 0;
	priv->screen_num = 0;
	priv->screen_width = -1;
	priv->screen_height = -1;
	priv->lex_mode = DMC_byte0;
	priv->swap_xy = 0;
	priv->button_down = FALSE;
	priv->button_number = 1;
	priv->proximity = FALSE;
	priv->pen_down = 0;

	pInfo->type_name = XI_TOUCHSCREEN;
	pInfo->device_control = DeviceControl;
	pInfo->read_input = ReadInput;
	pInfo->control_proc = ControlProc;
#if !XORG_NEWVERS110
	pInfo->close_proc = CloseProc;
#endif
	pInfo->switch_mode = SwitchMode;
#if !XORG_NEWVERS110
	pInfo->conversion_proc = ConvertProc;
#endif
	pInfo->dev = NULL;
	pInfo->private = priv;
#if XORG_NEWVERS110
	pInfo->flags = 0;
#else
	pInfo->private_flags = 0;
	pInfo->flags = XI86_POINTER_CAPABLE | XI86_SEND_DRAG_EVENTS;
	pInfo->conf_idev = dev;
	xf86CollectInputOptions(pInfo, default_options, NULL);
#endif

	xf86OptionListReport( pInfo->options );

	pInfo->fd = xf86OpenSerial (pInfo->options);
	if (pInfo->fd == -1)
	{
		ErrorF ("DMC driver unable to open device\n");
		goto SetupProc_fail;
	}
	xf86CloseSerial(pInfo->fd);
#if XORG_NEWVERS14
	if( (priv->consfd = open("/dev/tty1",O_RDWR|O_NDELAY)) >= 0 
	 || (priv->consfd = open("/dev/tty2",O_RDWR|O_NDELAY)) >= 0 
	 || (priv->consfd = open("/dev/tty3",O_RDWR|O_NDELAY)) >= 0 
	 || (priv->consfd = open("/dev/tty4",O_RDWR|O_NDELAY)) >= 0 )
		;
#endif
	/*
	 * Process the options for your device like this
	 */
	priv->pInfo = pInfo;
	priv->usb_dev = xf86SetIntOption( pInfo->options, "USB", 0 );
	priv->fd = pInfo->fd;
	priv->screen_num = xf86SetIntOption( pInfo->options, "ScreenNumber", 0 );
	priv->button_number = xf86SetIntOption( pInfo->options, "ButtonNumber", 1 );
	priv->swap_xy = xf86SetIntOption( pInfo->options, "SwapXY", 0 );
	priv->reverse_xy = xf86SetIntOption( pInfo->options, "ReverseXY", 0 );
	priv->buffer = NULL;
	priv->reporting_mode = TS_Scaled;
	priv->do_calib = 0;
	priv->tp_state = 0;
	priv->init_beep_on = xf86SetIntOption( pInfo->options, "InitBeep", 1 );

	priv->calib_point = xf86SetIntOption( pInfo->options, "CalibPoint", 2 );
	if( priv->screen_num == 0 )
		priv->save_file = xf86SetStrOption( pInfo->options, "SaveFile", CFG_CALIB_DATA_FILE);
	else
		priv->save_file = xf86SetStrOption( pInfo->options, "SaveFile", CFG_CALIB_DATA_FILE2);
#if defined(USE_PIPE_COMM)
	priv->apidir = xf86SetStrOption( pInfo->options, "ApiDir", API_DIR);
#endif
#ifndef XORG_OLDVERS
	priv->modpath = xf86SetStrOption( pInfo->options, "ModulePath", 0);
	xf86Msg(X_WARNING, "DMC(%d) : modpath=%x \n",priv->screen_num,priv->modpath);
#endif
	//read_save_file(priv);

	priv->proximity = FALSE;
	priv->button_down = FALSE;
	priv->lex_mode = DMC_byte0;
	priv->eeprom_read_ok = FALSE;

	if (QueryHardware (priv) != Success)
	{
		ErrorF ("Unable to query/initialize DMC hardware.\n");
		goto SetupProc_fail;
	}

	/* this results in an xstrdup that must be freed later */
	pInfo->name = xf86SetStrOption( pInfo->options, "DeviceName", "DMC");
	xf86ProcessCommonOptions(pInfo, pInfo->options);

#if !XORG_NEWVERS110
	pInfo->flags |= XI86_CONFIGURED;
#endif
	xf86Msg(X_WARNING, "DMC(%d) : Touch-Panel Driver %s\n",priv->screen_num,TBDRV_VERSION);
#if XORG_NEWVERS110
	return( Success );
#else
	return (pInfo);
#endif

  SetupProc_fail:
	if ((pInfo) && (pInfo->fd))
		xf86CloseSerial (pInfo->fd);
	if ((pInfo) && (pInfo->name))
		xfree (pInfo->name);
#if XORG_NEWVERS14
	if( priv->consfd >= 0 )
		close(priv->consfd);
#endif
	if ((priv) && (priv->buffer))
		XisbFree (priv->buffer);
	if (priv)
		xfree (priv);
#if XORG_NEWVERS110
	return( Success );
#else
	return (pInfo);
#endif
}

static Bool DeviceControl (DeviceIntPtr dev, int mode)
{
	InputInfoPtr pInfo = dev->public.devicePrivate;
	DMCPrivatePtr priv = (DMCPrivatePtr) (pInfo->private);
	unsigned char map[MAXBUTTONS+1] =
	{0, 1, 2, 3};
#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 7
    Atom btn_labels[MAXBUTTONS] = {0};
    Atom axes_labels[2] = {0};

    axes_labels[0] = XIGetKnownProperty(AXIS_LABEL_PROP_REL_X);
    axes_labels[1] = XIGetKnownProperty(AXIS_LABEL_PROP_REL_Y);

    btn_labels[0] = XIGetKnownProperty(BTN_LABEL_PROP_BTN_LEFT);
    btn_labels[1] = XIGetKnownProperty(BTN_LABEL_PROP_BTN_MIDDLE);
    btn_labels[2] = XIGetKnownProperty(BTN_LABEL_PROP_BTN_RIGHT);
#endif


	switch (mode)
	{
	case DEVICE_INIT:
		#if 1
		#if _3MEX2
			xf86Msg(X_WARNING, "DMC(%d) : DeviceControl INIT [HW:3M-EXII]\n",priv->screen_num);
		#else
			xf86Msg(X_WARNING, "DMC(%d) : DeviceControl INIT [HW:TSC10]\n",priv->screen_num);
		#endif
		#endif
		/*
		 * these have to be here instead of in the SetupProc, because when the
		 * SetupProc is run at server startup, screenInfo is not setup yet
		 */
		priv->screen_width = screenInfo.screens[priv->screen_num]->width;
		priv->screen_height = screenInfo.screens[priv->screen_num]->height;
		priv->max_x = priv->screen_width;
		priv->max_y = priv->screen_height;
		xf86Msg(X_WARNING, "DMC(%d) : SCREEN %d x %d max=%d,%d\n"
			,priv->screen_num,priv->screen_width,priv->screen_height,priv->max_x,priv->max_y);
		read_save_file(priv);
		/*
		 * Device reports button press for 1 button.
		 */
#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 7
		if (InitButtonClassDeviceStruct (dev, 3, btn_labels, map) == FALSE)
#else
		if (InitButtonClassDeviceStruct (dev, 3, map) == FALSE)
#endif
		{
			ErrorF ("Unable to allocate DMC ButtonClassDeviceStruct\n");
			return !Success;
		}
		
		/*
		 * Device reports motions on 2 axes in absolute coordinates.
		 * Axes min and max values are reported in raw coordinates.
		 */
#if XORG_NEWVERS110
		if (InitValuatorClassDeviceStruct (dev, 2, axes_labels,
						   GetMotionHistorySize(), Absolute) == FALSE)
#elif GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 7
		if (InitValuatorClassDeviceStruct (dev, 2, axes_labels,
						   pInfo->history_size, Absolute) == FALSE)
#elif GET_ABI_MAJOR(ABI_XINPUT_VERSION) < 3
		if (InitValuatorClassDeviceStruct (dev, 2, xf86GetMotionEvents,
						   pInfo->history_size, Absolute) == FALSE)
#else
		if (InitValuatorClassDeviceStruct (dev,2,0,Absolute) == FALSE)
#endif
		{
			ErrorF ("Unable to allocate DMC ValuatorClassDeviceStruct\n");
			return !Success;
		}
		else
		{
		#if XORG_NEWVERS110
			InitValuatorAxisStruct (dev, 0, axes_labels[0],
							priv->min_x, priv->max_x,
							9500,
							0 /* min_res */ ,
							9500 /* max_res */ ,
							Absolute);
			InitValuatorAxisStruct (dev, 1, axes_labels[1],
							priv->min_y, priv->max_y,
							10500,
							0 /* min_res */ ,
							10500 /* max_res */ ,
							Absolute);
		#elif GET_ABI_MAJOR(ABI_XINPUT_VERSION) >= 7
			InitValuatorAxisStruct (dev, 0, 0, axes_labels[0],0,1,0,1);
			InitValuatorAxisStruct (dev, 0, 0, axes_labels[1],0,1,0,1);
		#else
			InitValuatorAxisStruct (dev, 0, priv->min_x, priv->max_x,
							9500,
							0 /* min_res */ ,
							9500 /* max_res */ );
			InitValuatorAxisStruct (dev, 1, priv->min_y, priv->max_y,
							10500,
							0 /* min_res */ ,
							10500 /* max_res */ );
		#endif
		}
		
		if (InitProximityClassDeviceStruct (dev) == FALSE)
		{
			ErrorF ("unable to allocate DMC ProximityClassDeviceStruct\n");
			return !Success;
		}

		if (InitPtrFeedbackClassDeviceStruct(dev, DMCPtrCtrl) == FALSE)
		{
			ErrorF ("unable to allocate DMC PtrFeedbackClassDeviceStruct\n");
			return !Success;
		}

		/* 
		 * Allocate the motion events buffer.
		 */
		xf86MotionHistoryAllocate (pInfo);
		return (Success);
		
	case DEVICE_ON:
		#if 1
		xf86Msg(X_WARNING, "DMC(%d) : DeviceControl ON\n",priv->screen_num);
		#endif
		pInfo->fd = xf86OpenSerial(pInfo->options);
		if (pInfo->fd == -1)
		{
			xf86Msg(X_WARNING, "%s: cannot open input device\n", pInfo->name);
			return (!Success);
		}
		priv->fd = pInfo->fd;
		priv->buffer = XisbNew(pInfo->fd, 256);	// 64->256
		if (!priv->buffer)
		{
			xf86CloseSerial(pInfo->fd);
			pInfo->fd = -1;
			return (!Success);
		}
		else
		{
			priv->do_calib = 0;
			asleep(priv,1);	/* touch need ca. 500ms delay !!! */
			if( !priv->usb_dev )
				init_dev(priv,false);
			else if( !init_dev(priv,false) )
				return (!Success);
			priv->lex_mode = DMC_Response0;
		}

		XisbBlockDuration (priv->buffer, -1);
		priv->lex_mode = DMC_byte0;

		xf86FlushInput(pInfo->fd);
		AddEnabledDevice (pInfo->fd);
		dev->public.on = TRUE;
		return (Success);

	case DEVICE_OFF:
	case DEVICE_CLOSE:
		#if 1
		xf86Msg(X_WARNING, "DMC(%d) : DeviceControl OFF/CLOSE\n",priv->screen_num);
		#endif
		if (pInfo->fd != -1)
		{ 
			RemoveEnabledDevice (pInfo->fd);
			if (priv->buffer)
			{
				XisbFree(priv->buffer);
				priv->buffer = NULL;
			}
			xf86CloseSerial(pInfo->fd);
		}
		dev->public.on = FALSE;
		return (Success);
	default:
		#if 1
		xf86Msg(X_WARNING, "DMC(%d) : DeviceControl No\n",priv->screen_num);
		#endif
		return (BadValue);
	}

}


/* 
 * The ReadInput function will have to be tailored to your device
 */
#if XORG_NEWVERV112
void xf86XInputSetScreen(InputInfoPtr	pInfo,
		    int			screen_number,
		    int			x,
		    int			y)
{
	if (miPointerGetScreen(pInfo->dev) !=
		screenInfo.screens[screen_number]) {
	miPointerSetScreen(pInfo->dev, screen_number, x, y);
	}
}
#endif

static void ReadInput (InputInfoPtr pInfo)
{
	DMCPrivatePtr priv = (DMCPrivatePtr) (pInfo->private);
	int x,y,svx,svy;
	char pre_pen;

	/* 
	 * set blocking to -1 on the first call because we know there is data to
	 * read. Xisb automatically clears it after one successful read so that
	 * succeeding reads are preceeded buy a select with a 0 timeout to prevent
	 * read from blocking indefinately.
	 */
//xf86Msg(X_WARNING, "DMC(%d) : ReadInput entry\n",priv->screen_num);
	XisbBlockDuration (priv->buffer, -1);
	while (1)
	{
	#if 0
		xf86Msg(X_WARNING, "DMC(%d) : ReadInput wait\n",priv->screen_num);
	#endif
		if ( DMCGetPacket (priv) != Success)
			break;
	#if 0
		xf86Msg(X_WARNING, "DMC(%d) : ReadInput $%x\n",priv->screen_num,priv->packet[0]);
	#endif
		pre_pen = priv->pen_down;
	#if	_3MEX2
		if ( (priv->packet[0]&0x40) )
			priv->pen_down = 1;
		else
			priv->pen_down = 0;
		//priv->packet[0] |= priv->pen_down;
		if ( priv->swap_xy)
		{
			y = priv->packet[1]+(priv->packet[2]<<7);
			x = priv->packet[3]+(priv->packet[4]<<7);
		}
		else
		{
			x = priv->packet[1]+(priv->packet[2]<<7);
			y = priv->packet[3]+(priv->packet[4]<<7);
		}
		x >>= 4;
		y >>= 4;
		y = TP_MAX_Y - 1 - y;
	#else
		if ( priv->packet[0] == 0x11 )
			priv->pen_down = 1;
		else
			priv->pen_down = 0;
		if( priv->usb_dev )
		{
			if ( priv->swap_xy)
			{
				y = priv->packet[2]*256+priv->packet[1];
				x = priv->packet[4]*256+priv->packet[3];
			}
			else
			{
				x = priv->packet[2]*256+priv->packet[1];
				y = priv->packet[4]*256+priv->packet[3];
			}
		}
		else
		{
			if ( priv->swap_xy)
			{
				y = priv->packet[1]*256+priv->packet[2];
				x = priv->packet[3]*256+priv->packet[4];
			}
			else
			{
				x = priv->packet[1]*256+priv->packet[2];
				y = priv->packet[3]*256+priv->packet[4];
			}
		}
	#endif
		if ( priv->reverse_xy)
		{
			x = 1024 - 1 - x;
			y = 1024 - 1 - y;
			//x = 1013 - x;
			//y = 1000 - y;
		}
		//priv->packet[0] = priv->pen_down ? 0x01 : 0x00;
	#if CHG_SCR_RESOLUTION
		if( priv->screen_width != screenInfo.screens[priv->screen_num]->width 
		 || priv->screen_height != screenInfo.screens[priv->screen_num]->height )
		{
			adj_chg_resolution(priv);
		}
	#endif
	#if 0
		xf86Msg(X_WARNING, "DMC(%d) ReadInput (x,y)=(%d,%d) %02x %02x %02x %02x %02x %02x \n"
						,priv->screen_num
						,x,y
						,priv->packet[0]
						,priv->packet[1],priv->packet[2],priv->packet[3],priv->packet[4]
						,priv->packet[5]);
	#endif
		if( !adjust_xy(priv,x,y,&x,&y) )
		{
		#if 1
			continue;
		#else
			break;
		#endif
		}
		svx = 0;
		svy = 0;
		if( priv->reporting_mode == TS_Raw )
		{
			svx = x;
			svy = y;
			x = 0;
			y = 0;
		}
		if( pre_pen != priv->pen_down || priv->samp_rate == RATE_PMODE )
			ring_beep(priv);
		xf86XInputSetScreen (pInfo, priv->screen_num, x, y);
	#if 0
		xf86Msg(X_WARNING, "DMC(%d) ReadInput (x,y)=(%d,%d) %d $%x\n"
			,priv->screen_num,x,y,priv->pen_down,miPointerCurrentScreen());
	#endif
		if ((priv->proximity == FALSE) && priv->pen_down )
		{
			priv->proximity = TRUE;
			xf86PostProximityEvent (pInfo->dev, 1, 0, 2, x, y);
		}
		/*
		 * Send events.
		 *
		 * We *must* generate a motion before a button change if pointer
		 * location has changed as DIX assumes this. This is why we always
		 * emit a motion, regardless of the kind of packet processed.
		 */
		if( !priv->button_down && priv->pen_down )
		{	
			/* multi-display(=spanning setup only) bug avoidance */
			xf86PostMotionEvent (pInfo->dev, TRUE, 0, 2, x, y+1);
		}
		xf86PostMotionEvent (pInfo->dev, TRUE, 0, 2, x, y);
		/*
		 * Emit a button press or release.
		 */
		if( !priv->button_down && priv->pen_down )
		{
			if( priv->tp_state & B_SELECT_MID )
				priv->button_number = 2;
			else if( priv->tp_state & B_SELECT_RIGHT )
				priv->button_number = 3;
			else
				priv->button_number = 1;
			xf86PostButtonEvent (pInfo->dev, TRUE,priv->button_number, 1, 0, 2, x, y);
			priv->button_down = TRUE;
		}
        if( priv->samp_rate == RATE_PMODE
		 || (priv->button_down && !priv->pen_down) )
		{
			xf86PostButtonEvent (pInfo->dev, TRUE, priv->button_number, 0, 0, 2, x, y);
			priv->button_down = FALSE;
			priv->calib_raw_x = svx;
			priv->calib_raw_y = svy;
			if( priv->tp_state & MASK_SELECT )
				priv->button_number = 1;
			priv->tp_state &= (~MASK_SELECT);
		}
		/*
		 * the untouch should always come after the button release
		 */
		if ((priv->proximity == TRUE) && !priv->pen_down )
		{
			priv->proximity = FALSE;
			xf86PostProximityEvent (pInfo->dev, 0, 0, 2, x, y);
		}
	}
#if 0
	xf86Msg(X_WARNING, "DMC(%d) : ReadInput exit\n",priv->screen_num);
#endif
}

/*
 * The ControlProc function may need to be tailored for your device
 */
static int ControlProc (InputInfoPtr pInfo, xDeviceCtl * control)
{
#if 0
	xDeviceTSCalibrationCtl *c = (xDeviceTSCalibrationCtl *) control;
	DMCPrivatePtr priv = (DMCPrivatePtr) (pInfo->private);

#if DEBUG_DMC
xf86Msg(X_WARNING, "DMC(%d) : ControlProc %d %d %d %d\n"
					,priv->screen_num,c->min_x,c->min_y,c->max_x,c->max_y);
#endif
	priv->min_x = c->min_x;
	priv->max_x = c->max_x;
	priv->min_y = c->min_y;
	priv->max_y = c->max_y;
#else
#ifndef XORG_NEWVERS
	xDeviceResolutionCtl *c = (xDeviceResolutionCtl *) control;
#if DEBUG_DMC
	int *p = (int *)(c + 1);
	xf86Msg(X_WARNING, "DMC(%d) : ControlProc %d %d (%d %d %d %d)\n"
					,priv->screen_num,c->first_valuator,c->num_valuators,p[0],p[1],p[2],p[3]);
#endif 
#endif
#endif 
	return (Success);
}

/* 
 * the CloseProc should not need to be tailored to your device
 */
static void CloseProc (InputInfoPtr pInfo)
{

}

/* 
 * the QueryHardware fuction should be tailored to your device to
 * verify the device is attached and functional and perform any
 * needed initialization.
 */
static Bool QueryHardware (DMCPrivatePtr priv)
{
	/* Maybe once we get the hardware to actually respond correctly to its 
	   configuration 'packets' */

	return (Success);
}

/* 
 * This function should be renamed for your device and tailored to handle
 * your device's protocol.
 */
static Bool DMCGetPacket (DMCPrivatePtr priv)
{
	int count = 0;
	int c;

	while ((c = XisbRead (priv->buffer)) >= 0)
	{
#if 0
xf86Msg(X_WARNING, "DMC(%d) $%x\n",priv->screen_num,c);
#endif
		/*
		 * fail after 500 bytes so the server doesn't hang forever if a
		 * device sends bad data.
		 */
		if (count++ > 500)
			return (!Success);

		switch (priv->lex_mode)
		{
		case DMC_byte0:
			if( c == 0x12 )
			{
				xf86Msg(X_WARNING, "DMC(%d) $%x reinit-char\n",priv->screen_num,c);
				init_dev(priv,true);
				XisbBlockDuration (priv->buffer, -1);
				priv->lex_mode = DMC_byte0;
				return (!Success);
			}
		#if _3MEX2
			if( ( c & 0xc0 ) != 0x80 && ( c & 0xc0 ) != 0xc0 )
				return (!Success);
			priv->packet[0] = (unsigned char) c & 0x40;
		#else
		#if 0
			if ((( c & 0x3f ) != 0x11 ) &&
				(( c & 0x3f ) != 0x10 ))
					return (!Success);
		#else
			if (( c & 0x3f ) == 0x10 )
			{
				priv->packet[0] = (unsigned char) c & 0x3f;
				if( priv->usb_dev == 0 )
					return (Success);
			}
			else if (( c & 0x3f ) != 0x11 )
				return (!Success);
		#endif
			priv->packet[0] = (unsigned char) c & 0x3f;
		#endif
			priv->lex_mode = DMC_byte1;
			break;

		case DMC_byte1:
			priv->packet[1] = (unsigned char) c;
			priv->lex_mode = DMC_byte2;
			break;

		case DMC_byte2:
			priv->packet[2] = (unsigned char) c;
			priv->lex_mode = DMC_byte3;
			break;

		case DMC_byte3:
			priv->packet[3] = (unsigned char) c;
			priv->lex_mode = DMC_byte4;
			break;

		case DMC_byte4:
			priv->packet[4] = (unsigned char) c;
			priv->lex_mode = DMC_byte0;
			return (Success);
			break;

		case DMC_Response0:
			priv->packet[0] = (unsigned char) c;
			return (Success);
			break;

		}
	}
	return (!Success);
}

static Bool DMCSendPacket (DMCPrivatePtr priv, unsigned char *buf, int len)
{
	int				count = 0;
#if _3MEX2
	return (Success);
#else
	if( priv->usb_dev )
		return (Success);
	while ( len > 0 )
	{
		if ( XisbWrite(priv->buffer, buf, 1) == 1 )
		{
			buf++;
			len--;
			continue;
		}
		if ( count++ > 500 )
			break;
	}
	return (len ? !Success : Success);
#endif
}

static void DMCPtrCtrl(DeviceIntPtr device, PtrCtrl *ctrl)
{
  /* I have no clue what this does, except that registering it stops the
     X server segfaulting in ProcGetPointerMapping()
     Ho Hum.
  */
}
static int ring_beep(DMCPrivatePtr priv)
{
int a;
	a = 0;
	if( priv->reporting_mode == TS_Raw )
	{
		if( priv->pen_down == 0 )
			a = 1;
	}
	else
	{
		if( ( (priv->tp_state & B_BELL_DOWN) && priv->pen_down == 1 )
	 	|| ( (priv->tp_state & B_BELL_UP)   && priv->pen_down == 0 ) )
			a = 1;
	}
	if( a )
#if XORG_NEWVERS14
	{
		if( priv->consfd >= 0 )
			ioctl(priv->consfd,KDMKTONE,CONS_BEEP_VAL);
	}
#else
		xf86SoundKbdBell(100,880,15);
#endif
	return(0);
}

/**************************************************************************************/

/*
 * The ConvertProc function may need to be tailored for your device.
 * This function converts the device's valuator outputs to x and y coordinates
 * to simulate mouse events.
 */
static Bool ConvertProc (InputInfoPtr pInfo,int first,int num
				,int v0,int v1,int v2,int v3,int v4,int v5,int *x, int *y)
{
	DMCPrivatePtr priv = (DMCPrivatePtr) (pInfo->private);

	*x = v0;
	*y = v1;
#if DEBUG_DISP_POINT
xf86Msg(X_WARNING, "DMC(%d) : ConvertProc (%4d,%4d) (%4d,%4d)\n",priv->screen_num,*x,*y,v0,v1);
#endif
	return (TRUE);
}
BOOL adjust_xy(DMCPrivatePtr priv,int inx,int iny,int *x,int *y)
{
NTIME tm;
int dp;
int def,sx,sy,ex,ey,rsx,rsy,rex,rey,a,b,c,orgx,orgy;
uARect *rp,*ap;
	if( priv->reporting_mode == TS_Raw )
	{
		tm = get_time();
		if( priv->reporting_time == 0 )
			priv->reporting_time = tm;
		else
		{
			if( !priv->pen_down )
			{
				if( diff_time(tm,priv->reporting_time) < 300 )
				{
					priv->reporting_time = 0;
					return(false);
				}
				priv->reporting_time = 0;
			}
		}
		return(true);
	}
	orgx = inx;
	orgy = iny;
	def = 1;
	if (priv->reporting_mode == TS_Scaled)
	{
		rp = priv->calib_run_raw_r;
		ap = priv->calib_run_adj_r;
	}
	else
	{
		rp = priv->calib_temp_run_raw_r;
		ap = priv->calib_temp_run_adj_r;
	}
	if( rp[0].lefttop.x < rp[0].righttop.x )
	{
		/* begin (0,0) is left-top */
		if( inx <= rp[0].rightbottom.x && iny <= rp[0].rightbottom.y )
		{
			dp = 0;
			rp = &rp[0];
			ap = &ap[0];
		}
		else if( inx <= rp[1].righttop.x && iny >= rp[1].righttop.y )
		{
			dp = 1;
			rp = &rp[1];
			ap = &ap[1];
		}
		else if( inx >= rp[2].leftbottom.x && iny <= rp[2].leftbottom.y )
		{
			dp = 2;
			rp = &rp[2];
			ap = &ap[2];
		}
		else
		{
			dp = 3;
			rp = &rp[3];
			ap = &ap[3];
		}
	}
	else
	{
		/* begin (0,0) is right-bottom */
		if( inx >= rp[0].rightbottom.x && iny >= rp[0].rightbottom.y )
		{
			dp = 0;
			rp = &rp[0];
			ap = &ap[0];
		}
		else if( inx >= rp[1].righttop.x && iny <= rp[1].righttop.y )
		{
			dp = 1;
			rp = &rp[1];
			ap = &ap[1];
		}
		else if( inx <= rp[2].leftbottom.x && iny >= rp[2].leftbottom.y )
		{
			dp = 2;
			rp = &rp[2];
			ap = &ap[2];
		}
		else
		{
			dp = 3;
			rp = &rp[3];
			ap = &ap[3];
		}
	}
//xf86Msg(X_WARNING, "DMC(%d) : dp=%d %d,%d\n",priv->screen_num,dp,inx,iny);
	rsx = rp->lefttop.x;
	rex = rp->rightbottom.x;
	sx  = ap->lefttop.x;
	ex  = ap->rightbottom.x;
	rsy = rp->lefttop.y;
	rey = rp->rightbottom.y;
	sy  = ap->lefttop.y;
	ey  = ap->rightbottom.y;
	//
	a = (ex - sx);
	b = (rex - rsx);
	if( b == 0 )
		def = 0;
	else
	{
		*x = (((inx - rsx) * a) / b) + sx;
		if( *x >= priv->max_x )
			*x = priv->max_x - 1;
		if( *x < 0 )
			*x = 0;
	}
#if 0
	xf86Msg(X_WARNING, "DMC(%d) : ADJX %4d -> %4d -> %4d [%4d/%4d]\n",priv->screen_num,orgx,inx,*x,a,b);
#endif
	a = (ey - sy);
	b = (rey - rsy);
	if( b == 0 )
		def = 0;
	else
	{
		*y = (((iny - rsy) * a) / b) + sy;
		if( *y >= priv->max_y )
			*y = priv->max_y - 1;
		if( *y < 0 )
			*y = 0;
	}
#if 0
	xf86Msg(X_WARNING, "DMC(%d) : ADJY %4d -> %4d -> %4d [%4d/%4d]\n",priv->screen_num,orgy,iny,*y,a,b);
#endif
	if( def == 0 )
	{
		*x = inx;
		*y = iny;
	}
#if 0
	xf86Msg(X_WARNING, "DMC(%d) : %d = (%4d,%4d)\n",priv->screen_num,dp,*x,*y);
#endif
	return(true);
}

#if USE_PIPE_COMM
/* 
 * The SwitchMode function may need to be tailored for your device
 */
static int SwitchMode (ClientPtr client, DeviceIntPtr dev, int mode)
{
InputInfoPtr pInfo = dev->public.devicePrivate;
DMCPrivatePtr priv = (DMCPrivatePtr) (pInfo->private);
dmc_pkt pkt;
dmc_pktres respkt,*rp;
dmc_pktresinfo infpkt;
int ressize;
int sz,res;
DMCState st;
#if DEBUG_DMC
xf86Msg(X_WARNING, "DMC(%d) : SwitchMode mode=$%08x $%08x\n",priv->screen_num,mode,SendCoreEvents);
#endif
#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) == 0
	if ((mode == SendCoreEvents) || (mode == DontSendCoreEvents))
	{
		xf86XInputSetSendCoreEvents (pInfo, (mode == SendCoreEvents));
	}
	else
#endif
	if( mode == XDEV_KICK )
	{
		#if DEBUG_APCMD
		xf86Msg(X_WARNING, "DMC(%d) : SwitchMode XDEV_KICK\n",priv->screen_num);
		#endif
		if( read_dmcpkt(priv,&pkt,sizeof(dmc_pktheader)) <= 0 )
			return (!Success);
		#if DEBUG_APCMD
		xf86Msg(X_WARNING, "DMC(%d) : cmd=%d %04x %04x\n"
			,priv->screen_num,pkt.u.pnorm.hd.cmd,pkt.u.pnorm.hd.cmd,pkt.u.pnorm.hd.rsv);
		#endif
		sz = sizeof(dmc_pktnorm)-sizeof(dmc_pktheader);
		res = 0;
		rp = &respkt;
		ressize = sizeof(respkt);
		switch( pkt.u.pnorm.hd.cmd )
		{
		case SET_MEM:
			sz = sizeof(dmc_pktrwmem)-sizeof(dmc_pktheader);
			if( (res = read_dmcpkt(priv,&pkt.u.rwmem.addr,sz)) <= 0 )
				break;
			res = tx_set_mem(priv,pkt.u.rwmem.addr,pkt.u.rwmem.dat);
			break;
		case GET_MEM:
			sz = sizeof(dmc_pktrwmem)-sizeof(dmc_pktheader);
			if( (res = read_dmcpkt(priv,&pkt.u.rwmem.addr,sz)) <= 0 )
				break;
			res = tx_get_mem(priv,pkt.u.rwmem.addr);
			break;
		case SET_RATE_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : rate=%d\n",priv->screen_num,pkt.u.pnorm.dat);
			#endif
			res = 0;
			priv->samp_rate = pkt.u.pnorm.dat;
			if( !specify_set(priv) )
				res = -1;
			break;
		case GET_RATE_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : get rate\n",priv->screen_num);
			#endif
			res = priv->samp_rate;
			break;
		case SET_BEEP_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : beep=%d\n",priv->screen_num,pkt.u.pnorm.dat);
			#endif
			res = 0;
			switch( pkt.u.pnorm.dat )
			{
			case BEEP_DOWN_ON:	priv->tp_state |= B_BELL_DOWN;		break;
			case BEEP_DOWN_OFF:	priv->tp_state &= (~B_BELL_DOWN);	break;
			case BEEP_UP_ON:	priv->tp_state |= B_BELL_UP;		break;
			case BEEP_UP_OFF:	priv->tp_state &= (~B_BELL_UP);		break;
			}
			break;
		case GET_BEEP_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : get beep\n",priv->screen_num);
			#endif
			res = 0;
			if( priv->tp_state & B_BELL_DOWN )
				res |= (1 << B_BEEP_DOWN_ON);
			if( priv->tp_state & B_BELL_UP )
				res |= (1 << B_BEEP_UP_ON);
			break;
		case SET_OFFDELAY:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : offdelay=%d\n",priv->screen_num,pkt.u.pnorm.dat);
			#endif
			if( (res = tx_set_offdelay(priv,pkt.u.pnorm.dat)) >= 0 )
				priv->offdelay = (int)pkt.u.pnorm.dat;
			break;
		case GET_OFFDELAY:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : get offdelay\n",priv->screen_num);
			#endif
			if( (res = tx_get_offdelay(priv)) >= 0 )
				priv->offdelay = res;
			break;
		case GET_CALIBNUM_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : get calib point num\n",priv->screen_num);
			#endif
			res = priv->calib_point;
			break;
		case GET_INFO_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : get info\n",priv->screen_num);
			#endif
			infpkt.screen_num = priv->screen_num;
			infpkt.max_x = priv->max_x;
			infpkt.max_y = priv->max_y;
			infpkt.beep = priv->tp_state & 3;
			infpkt.rate = priv->samp_rate;
			infpkt.offdelay = priv->offdelay;
			infpkt.select = (priv->tp_state & MASK_SELECT) >> 4;
			infpkt.eeprom_read_ok = priv->eeprom_read_ok;
			infpkt.calib_point = priv->calib_point;
			rp = &infpkt;
			ressize = sizeof(infpkt);
			res = 0;
			break;
		case SAVE_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			res = 0;
			write_save_file(priv,true);
			break;
		case RESET_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : RESET\n",priv->screen_num);
			#endif
			res = 0;
			st = priv->lex_mode;
			if( tx_specify_goto_idle(priv,true) )
				goto_xyp(priv);
			else
			{
				XisbBlockDuration (priv->buffer, -1);
				priv->lex_mode = st;
				res = -1;
			}
			XisbBlockDuration (priv->buffer, -1);
			priv->lex_mode = st;
			break;
		case SET_SELECTOR_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : selector=%d\n",priv->screen_num,pkt.u.pnorm.dat);
			#endif
			res = 0;
			switch( pkt.u.pnorm.dat )
			{
			case SELECT_LEFT:
				priv->tp_state
					= (priv->tp_state & (~MASK_SELECT)) | B_SELECT_LEFT;
				break;
			case SELECT_MID:
				priv->tp_state
					= (priv->tp_state & (~MASK_SELECT)) | B_SELECT_MID;
				break;
			case SELECT_RIGHT:
				priv->tp_state
					= (priv->tp_state & (~MASK_SELECT)) | B_SELECT_RIGHT;
				break;
			}
			break;
		case GET_SELECTOR_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) <= 0 )
				break;
			#if DEBUG_APCMD
			xf86Msg(X_WARNING, "DMC(%d) : get selector\n",priv->screen_num);
			#endif
			res = 0;
			if( priv->tp_state & B_SELECT_LEFT )
				res = SELECT_LEFT;
			else if( priv->tp_state & B_SELECT_MID )
				res = SELECT_MID;
			else if( priv->tp_state & B_SELECT_RIGHT )
				res = SELECT_RIGHT;
			else
				res = SELECT_LEFT;
			break;
		case CALIB_FIRST_CMD:
			sz = sizeof(dmc_pktcalib)-sizeof(dmc_pktheader);
			if( (res = read_dmcpkt(priv,&pkt.u.pcalib.calib_point,sz)) != -1 )
			{
				#if DEBUG_APCMD
				xf86Msg(X_WARNING, "DMC(%d) : calib 1st\n",priv->screen_num);
				#endif
				res = calib_cmd_exec(priv,&pkt,pInfo);
			}
			break;
		case CALIB_NEXT_CMD:
		case CALIB_END_CMD:
		case CALIB_CANCEL_CMD:
		case CALIB_OK_CMD:
			if( (res = read_dmcpkt(priv,&pkt.u.pnorm.dat,sz)) != -1 )
			{
				#if DEBUG_APCMD
				xf86Msg(X_WARNING, "DMC(%d) : calib exec\n",priv->screen_num);
				#endif
				res = calib_cmd_exec(priv,&pkt,pInfo);
			}
			break;
		default:
			xf86Msg(X_WARNING, "DMC(%d) : unkown cmd pkt\n",priv->screen_num);
			res = -1;
			break;
		}
		rp->hd.cmd = pkt.u.pnorm.hd.cmd;
		rp->res = res;
		send_dmcpkt(priv,rp,ressize);
		#if DEBUG_APCMD
		xf86Msg(X_WARNING, "DMC(%d) : send_dmcpkt cmd=%d res=%d sz=%d\n"
						,priv->screen_num,rp->hd.cmd,rp->res,ressize);
		#endif
	}
	return(Success);
}
static int read_dmcpkt(DMCPrivatePtr priv,void *p,int size)
{
int res;
char s[256];
	if( priv->pin <= 0 )
	{
		if( priv->screen_num == 0 )
			sprintf(s,"%s",DMC_PIPE_TX_FILE);
		else
			sprintf(s,"%s%d",DMC_PIPE_TX_FILE,priv->screen_num);
		if( (priv->pin = open(s,O_RDONLY)) == -1 )
			return(-1);
		xf86Msg(X_WARNING, "DMC(%d) : read_dmcpkt %d = %s\n",priv->screen_num,priv->pin,s);
	}
	#if 0
	xf86Msg(X_WARNING, "DMC(%d) : read_dmcpkt in size=%d\n",priv->screen_num,size);
	#endif
	res = read(priv->pin,p,size);
	#if 0
	xf86Msg(X_WARNING, "DMC(%d) : read_dmcpkt res=%d\n",priv->screen_num,res);
	#endif
	return(res);
}
static int send_dmcpkt(DMCPrivatePtr priv,void *p,int size)
{
int res;
char s[256];
	if( priv->pout <= 0 )
	{
		if( priv->screen_num == 0 )
			sprintf(s,"%s",DMC_PIPE_RX_FILE);
		else
			sprintf(s,"%s%d",DMC_PIPE_RX_FILE,priv->screen_num);
		if( (priv->pout = open(s,O_RDWR)) == -1 )
			return(-1);
		xf86Msg(X_WARNING, "DMC(%d) : send %d = %s\n",priv->screen_num,priv->pout,s);
	}
	#if 0
	xf86Msg(X_WARNING, "DMC(%d) : send_dmcpkt in size=%d\n",priv->screen_num,size);
	#endif
	res = write(priv->pout,p,size);
	#if 0
	xf86Msg(X_WARNING, "DMC(%d) : send_dmcpkt res=%d\n",priv->screen_num,res);
	#endif
	return(res);
}
static int calib_cmd_exec(DMCPrivatePtr priv,dmc_pkt *pkt,InputInfoPtr pInfo)
{
	switch( pkt->u.pnorm.hd.cmd )
	{
	case	CALIB_FIRST_CMD:
		priv->reporting_mode = TS_Raw;
		calib_set(priv,pkt);
		break;
	case CALIB_NEXT_CMD:
		calib_set(priv,pkt);
		break;
	case CALIB_END_CMD:
		calib_set(priv,pkt);
		priv->reporting_mode = 0;
		break;
	case CALIB_CANCEL_CMD:
		calib_set(priv,pkt);
		priv->reporting_mode = TS_Scaled;
		break;
	case CALIB_OK_CMD:
		if( !calib_set(priv,pkt) )
		{
			priv->reporting_mode = TS_Scaled;
			return(-1);
		}
		priv->reporting_mode = TS_Scaled;
		break;
	default:
		return(-1);
	}
	return(0);
}
static Bool calib_set(DMCPrivatePtr priv,dmc_pkt *pkt)
{
int pt,res,ofs;
DMCState st;
	switch( pkt->u.pnorm.hd.cmd )
	{
	case	CALIB_FIRST_CMD: // init& set adjust(=refernce) data in temporary
		priv->do_calib = 0;
		priv->reporting_time = 0;
		priv->calib_temp_point = pkt->u.pcalib.calib_point;
		for( pt=0 ; pt < 16 ; pt++ )
		{
			priv->calib_temp_data[pt][0] = 0;
			priv->calib_temp_data[pt][1] = 0;
			priv->calib_temp_data[pt][2] = pkt->u.pcalib.adj[pt].x;
			priv->calib_temp_data[pt][3] = pkt->u.pcalib.adj[pt].y;
		}
		break;
	case	CALIB_NEXT_CMD:	// set data
		if( (pt = priv->do_calib) >= MAX_CALIB_POINT )
			break;
		priv->calib_temp_raw_data[pt][0] = priv->calib_raw_x;
		priv->calib_temp_raw_data[pt][1] = priv->calib_raw_y;
		pt++;
		priv->do_calib = pt;
		priv->reporting_time = 0;
		break;
	case	CALIB_END_CMD:		// set end
		set_temp_data(priv,priv->do_calib,0,priv->calib_temp_raw_data);
		#if ADJ_CALIB_DEFSCR
			adj_temp_data_on_defscr(priv);
		#endif
		set_calib_area(priv,true);
		break;
	case	CALIB_CANCEL_CMD:	// set end
		break;
	case	CALIB_OK_CMD:	// data complete & set!!
		priv->calib_point = priv->do_calib;
		memcpy(priv->calib_data,priv->calib_temp_data,sizeof(priv->calib_data));
		set_calib_area(priv,false);
		write_save_file(priv,false);
		st = priv->lex_mode;
		if( (res = tx_xyp_exit_goto_idle(priv,false)) )
		{
			asleep(priv,1);
			xf86FlushInput(priv->fd);
			res = priv->eeprom_read_ok ? write_eeprom(priv) : true;
			if( !goto_xyp(priv) )
				res = false;
		}
		XisbBlockDuration (priv->buffer, -1);
		priv->lex_mode = st;
		if( !res )
			return(false);
		break;
	}
	return(true);
}
#else /* else not USE_PIPE_COMM */
/* 
 * The SwitchMode function may need to be tailored for your device
 */
static int SwitchMode (ClientPtr client, DeviceIntPtr dev, int mode)
{
	InputInfoPtr pInfo = dev->public.devicePrivate;
	DMCPrivatePtr priv = (DMCPrivatePtr) (pInfo->private);

#if DEBUG_DMC
xf86Msg(X_WARNING, "DMC(%d) : SwitchMode mode=$%08x \n",priv->screen_num,mode);
#endif
	if ((mode == SendCoreEvents) || (mode == DontSendCoreEvents))
	{
		xf86XInputSetSendCoreEvents (pInfo, (mode == SendCoreEvents));
	}
	else if( mode >= (S_RATE_CMD+START_S_RATE) && mode <= (S_RATE_CMD+END_S_RATE) )
	{
		priv->samp_rate = mode & S_RATE_MASK;
		if( !specify_set(priv) )
			return (!Success);
	}
	else if( mode == BEEP_ON_DOWN_CMD )
	{
		priv->tp_state |= B_BELL_DOWN;
	}
	else if( mode == BEEP_OFF_DOWN_CMD )
	{
		priv->tp_state &= (~B_BELL_DOWN);
	}
	else if( mode == BEEP_ON_UP_CMD )
	{
		priv->tp_state |= B_BELL_UP;
	}
	else if( mode == BEEP_OFF_UP_CMD )
	{
		priv->tp_state &= (~B_BELL_UP);
	}
	else if( mode >= SELCT_CMD_start && mode <= SELCT_CMD_end )
	{
		switch( mode )
		{
		case SELCT_LEFT_CMD:
			priv->tp_state = (priv->tp_state & (~MASK_SELECT)) | B_SELECT_LEFT;
			break;
		case SELCT_MID_CMD:
			priv->tp_state = (priv->tp_state & (~MASK_SELECT)) | B_SELECT_MID;
			break;
		case SELCT_RIGHT_CMD:
			priv->tp_state = (priv->tp_state & (~MASK_SELECT)) | B_SELECT_RIGHT;
			break;
		case GET_SELCT_LEFT_CMD:
			return( priv->tp_state & B_SELECT_LEFT ? Success : !Success) ;
		case GET_SELCT_MID_CMD:
			return( priv->tp_state & B_SELECT_MID ? Success : !Success) ;
		case GET_SELCT_RIGHT_CMD:
			return( priv->tp_state & B_SELECT_RIGHT ? Success : !Success) ;
		}
	}
	else if( mode >= CALIB_CMD_RANGE_S && mode <= CALIB_CMD_RANGE_E )
		return( calib_cmd_exec(priv,mode,pInfo) );
	else if( mode == RESET_CMD )
	{
		DMCState st;
		st = priv->lex_mode;
		if( tx_specify_goto_idle(priv,true) )
			goto_xyp(priv);
		else
		{
			XisbBlockDuration (priv->buffer, -1);
			priv->lex_mode = st;
			return (!Success);
		}
		XisbBlockDuration (priv->buffer, -1);
		priv->lex_mode = st;
	}
	else
		return (!Success);
	return (Success);
}
/********************************************* calibration function start ***
 
 	Utiltiy 'tbcalib' Call.

		While input calibration point.
			--> CALIB_FIRST_CMD
					start calibration.
			--> CALIB_NEXT_CMD
					next calibration point.
					memory raw input touch data in this local driver's static.
		Input end.
			--> CALIB_END_CMD
		Push [OK] button
			--> CALIB_ADJ_DAT_CMD -> (CALIB_ADJ_DAT_CMD+MAX_CALIB_POINT-1)
					set adjsut calibration data.
			--> CALIB_OK_CMD
					end calibration & memory(=write eeprom) calibration data.
		Push [Cancel] button
			--> CALIB_CANCEL_CMD
					end calibration.
*/
static int calib_cmd_exec(DMCPrivatePtr priv,int mode,InputInfoPtr pInfo)
{
	if( mode == CALIB_PRE_FIRST_CMD )
	{
		calib_set(priv,10,(unsigned char)mode);
	}
	else if( mode == CALIB_FIRST_CMD )
	{
		priv->reporting_mode = TS_Raw;
		calib_set(priv,10,(unsigned char)mode);
	}
	else if( mode == CALIB_NEXT_CMD )
	{
		calib_set(priv,11,(unsigned char)mode);
	}
	else if( mode == CALIB_END_CMD )
	{
		calib_set(priv,3,(unsigned char)mode);
		priv->reporting_mode = 0;
	}
	else if( mode == CALIB_CANCEL_CMD )
	{
		calib_set(priv,10,(unsigned char)mode);
		priv->reporting_mode = TS_Scaled;
	}
	else if( mode == CALIB_OK_CMD )
	{
		if( !calib_set(priv,0,0) )
		{
			priv->reporting_mode = TS_Scaled;
			return (!Success);
		}
		priv->reporting_mode = TS_Scaled;
	}
	else if( mode >= CALIB_ADJ_DAT_CMD && mode < (CALIB_ADJ_DAT_CMD+MAX_CALIB_POINT) )
	{
		calib_set(priv,1,(unsigned char)mode);
	}
	else if( (mode & 0xf0) == CALIB_1_DAT )
	{
		calib_set(priv,2,(unsigned char)mode);
	}
	else
		return (!Success);
	return (Success);
}
static Bool calib_set(DMCPrivatePtr priv,int type,unsigned char a)
{
int pt,res,ofs;
DMCState st;
	switch( type )
	{
	case	0:	// data complete & set!!
		priv->calib_point = priv->do_calib;
		memcpy(priv->calib_data,priv->calib_temp_data,sizeof(priv->calib_data));
		set_calib_area(priv,false);
		write_save_file(priv,false);
		st = priv->lex_mode;
		if( (res = tx_xyp_exit_goto_idle(priv,false)) )
		{
			asleep(priv,1);
			xf86FlushInput(priv->fd);
			res = priv->eeprom_read_ok ? write_eeprom(priv) : true;
			if( !goto_xyp(priv) )
				res = false;
		}
		XisbBlockDuration (priv->buffer, -1);
		priv->lex_mode = st;
		if( !res )
			return(false);
		break;
	case	1:	// set point in temporary
		pt = priv->calib_temp_point = a & CALIB_MASK;
		priv->calib_temp_nibble = 0;
		for( a=0 ; a < MAX_DATA ; a++ )
			priv->calib_temp_data[pt][a] = 0;
		break;
	case	2:	// set adjust(=refernce) data in temporary
		if( priv->calib_temp_nibble >= (MAX_DATA*4) )
			priv->calib_temp_nibble = 0;
		pt = priv->calib_temp_point;
		a &= CALIB_MASK;
		ofs = priv->calib_temp_nibble / 4;
		priv->calib_temp_data[pt][ofs] <<= 4;
		priv->calib_temp_data[pt][ofs] |= a;
		priv->calib_temp_nibble++;
		break;
	case	3:	// set end
		set_temp_data(priv,priv->do_calib,0,priv->calib_temp_raw_data);
		#if ADJ_CALIB_DEFSCR
			adj_temp_data_on_defscr(priv);
		#endif
		set_calib_area(priv,true);
		break;
	case	10:	// init
		priv->do_calib = 0;
		priv->reporting_time = 0;
		break;
	case	11:	// set data
		if( (pt = priv->do_calib) >= MAX_CALIB_POINT )
			break;
		priv->calib_temp_raw_data[pt][0] = priv->calib_raw_x;
		priv->calib_temp_raw_data[pt][1] = priv->calib_raw_y;
		pt++;
		priv->do_calib = pt;
		priv->reporting_time = 0;
		break;
	}
	return(true);
}
#endif /* end USE_PIPE_COMM */

static int set_calib_area(DMCPrivatePtr priv,BOOL use_temp)
{
uARect *rp,*ap;
int pt,i;
unsigned int (*dat)[MAX_DATA];
	if( use_temp )
	{
		rp = priv->calib_temp_run_raw_r;
		ap = priv->calib_temp_run_adj_r;
		pt = priv->calib_temp_point;
		dat = priv->calib_temp_data;
	}
	else
	{
		rp = priv->calib_run_raw_r;
		ap = priv->calib_run_adj_r;
		pt = priv->calib_point;
		dat = priv->calib_data;
	}
	// dat[]
	//  0  1  2
	//  3  4  5
	//  6  7  8
	rp[0].lefttop.x		= dat[0][0];	rp[0].lefttop.y		= dat[0][1];
	rp[0].leftbottom.x	= dat[3][0];	rp[0].leftbottom.y	= dat[3][1];
	rp[0].righttop.x	= dat[1][0];	rp[0].righttop.y	= dat[1][1];
	rp[0].rightbottom.x	= dat[4][0];	rp[0].rightbottom.y	= dat[4][1];

	rp[1].lefttop.x		= dat[3][0];	rp[1].lefttop.y		= dat[3][1];
	rp[1].leftbottom.x	= dat[6][0];	rp[1].leftbottom.y	= dat[6][1];
	rp[1].righttop.x	= dat[4][0];	rp[1].righttop.y	= dat[4][1];
	rp[1].rightbottom.x	= dat[7][0];	rp[1].rightbottom.y	= dat[7][1];

	rp[2].lefttop.x		= dat[1][0];	rp[2].lefttop.y		= dat[1][1];
	rp[2].leftbottom.x	= dat[4][0];	rp[2].leftbottom.y	= dat[4][1];
	rp[2].righttop.x	= dat[2][0];	rp[2].righttop.y	= dat[2][1];
	rp[2].rightbottom.x	= dat[5][0];	rp[2].rightbottom.y	= dat[5][1];

	rp[3].lefttop.x		= dat[4][0];	rp[3].lefttop.y		= dat[4][1];
	rp[3].leftbottom.x	= dat[7][0];	rp[3].leftbottom.y	= dat[7][1];
	rp[3].righttop.x	= dat[5][0];	rp[3].righttop.y	= dat[5][1];
	rp[3].rightbottom.x	= dat[8][0];	rp[3].rightbottom.y	= dat[8][1];

	ap[0].lefttop.x		= dat[0][2];	ap[0].lefttop.y		= dat[0][3];
	ap[0].leftbottom.x	= dat[3][2];	ap[0].leftbottom.y	= dat[3][3];
	ap[0].righttop.x	= dat[1][2];	ap[0].righttop.y	= dat[1][3];
	ap[0].rightbottom.x	= dat[4][2];	ap[0].rightbottom.y	= dat[4][3];

	ap[1].lefttop.x		= dat[3][2];	ap[1].lefttop.y		= dat[3][3];
	ap[1].leftbottom.x	= dat[6][2];	ap[1].leftbottom.y	= dat[6][3];
	ap[1].righttop.x	= dat[4][2];	ap[1].righttop.y	= dat[4][3];
	ap[1].rightbottom.x	= dat[7][2];	ap[1].rightbottom.y	= dat[7][3];

	ap[2].lefttop.x		= dat[1][2];	ap[2].lefttop.y		= dat[1][3];
	ap[2].leftbottom.x	= dat[4][2];	ap[2].leftbottom.y	= dat[4][3];
	ap[2].righttop.x	= dat[2][2];	ap[2].righttop.y	= dat[2][3];
	ap[2].rightbottom.x	= dat[5][2];	ap[2].rightbottom.y	= dat[5][3];

	ap[3].lefttop.x		= dat[4][2];	ap[3].lefttop.y		= dat[4][3];
	ap[3].leftbottom.x	= dat[7][2];	ap[3].leftbottom.y	= dat[7][3];
	ap[3].righttop.x	= dat[5][2];	ap[3].righttop.y	= dat[5][3];
	ap[3].rightbottom.x	= dat[8][2];	ap[3].rightbottom.y	= dat[8][3];
#if DEBUG_CALIB_AREA
	for( i=0 ; i < 4 ; i++ )
		xf86Msg(X_WARNING, "DMC(%d) : raw area3 (%3d,%3d)-(%3d,%3d)-(%3d,%3d)-(%3d,%3d)\n"
							,priv->screen_num
							,rp[i].lefttop.x,    rp[i].lefttop.y
							,rp[i].leftbottom.x, rp[i].leftbottom.y
							,rp[i].righttop.x,   rp[i].righttop.y
							,rp[i].rightbottom.x,rp[i].rightbottom.y);
	for( i=0 ; i < 4 ; i++ )
		xf86Msg(X_WARNING, "DMC(%d) : adj area3 (%3d,%3d)-(%3d,%3d)-(%3d,%3d)-(%3d,%3d)\n"
							,priv->screen_num
							,ap[i].lefttop.x,    ap[i].lefttop.y
							,ap[i].leftbottom.x, ap[i].leftbottom.y
							,ap[i].righttop.x,   ap[i].righttop.y
							,ap[i].rightbottom.x,ap[i].rightbottom.y);
#endif
	return(0);
}
static int set_temp_data(DMCPrivatePtr priv,int calib_point,int ofs,unsigned int a[][2])
{
int i;
unsigned int temp[16][2];
	memcpy(temp,a,sizeof(temp));
	switch( calib_point )
	{
	case	2:
		// 0  -  -2    -> 0  1  2
		// -  -  -     -> 3  4  5
		// -3 -  1     -> 6  7  8
		temp[2][0] = temp[1][0];
		temp[2][1] = temp[0][1];
		temp[3][0] = temp[0][0];
		temp[3][1] = temp[1][1];
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[2]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[2],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[3]);
		caldif(&priv->calib_temp_data[4][ofs],temp[0],temp[1]);
		caldif(&priv->calib_temp_data[5][ofs],temp[2],temp[1]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[3],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[3],temp[1]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[1],sizeof(int)*2);
		break;
	case	3:
		// 0  -  -3    -> 0  1  2
		// -  1  -     -> 3  4  5
		// -4 -  2     -> 6  7  8
		temp[3][0] = temp[2][0];
		temp[3][1] = temp[0][1];
		temp[4][0] = temp[0][0];
		temp[4][1] = temp[2][1];
#if CALIB_PAT_A
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[1][ofs],temp[1],temp[0]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[3],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[3][ofs],temp[4],temp[1]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[1],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[5][ofs],temp[3],temp[1]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[4],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[7][ofs],temp[1],temp[4]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[2],sizeof(int)*2);
#else
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[3]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[3],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[4]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[1],sizeof(int)*2);
		caldif(&priv->calib_temp_data[5][ofs],temp[2],temp[3]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[4],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[2],temp[4]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[2],sizeof(int)*2);
#endif
		break;
	case	4:
		// 0  -  2     -> 0  1  2
		// -  -  -     -> 3  4  5
		// 1  -  3     -> 6  7  8
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[2]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[2],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[1]);
		caldif(&priv->calib_temp_data[4][ofs],temp[0],temp[3]);
		caldif(&priv->calib_temp_data[5][ofs],temp[2],temp[3]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[1],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[1],temp[3]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[3],sizeof(int)*2);
		break;
	case	5:
		// 0  -  3     -> 0  1  2
		// -  2  -     -> 3  4  5
		// 1  -  4     -> 6  7  8
#if CALIB_PAT_A
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[1][ofs],temp[2],temp[0]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[3],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[3][ofs],temp[1],temp[2]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[2],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[5][ofs],temp[3],temp[2]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[1],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[7][ofs],temp[2],temp[1]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[4],sizeof(int)*2);
#else
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[3]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[3],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[1]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[2],sizeof(int)*2);
		caldif(&priv->calib_temp_data[5][ofs],temp[3],temp[4]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[1],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[1],temp[4]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[4],sizeof(int)*2);
#endif
		break;
	case	6:
		// 0  2  4     -> 0  1  2
		// -  -  -     -> 3  4  5
		// 1  3  5     -> 6  7  8
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[1][ofs],temp[2],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[2][ofs],temp[4],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[1]);
		caldif(&priv->calib_temp_data[4][ofs],temp[0],temp[5]);
		caldif(&priv->calib_temp_data[5][ofs],temp[4],temp[5]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[1],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[7][ofs],temp[3],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[8][ofs],temp[5],sizeof(int)*2);
		break;
	case	9:
		// 0  3  6     -> 0  1  2
		// 1  4  7     -> 3  4  5
		// 2  5  8     -> 6  7  8
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[1][ofs],temp[3],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[2][ofs],temp[6],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[3][ofs],temp[1],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[4][ofs],temp[4],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[5][ofs],temp[7],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[6][ofs],temp[2],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[7][ofs],temp[5],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[8][ofs],temp[8],sizeof(int)*2);
		break;
	}
	return( 0 );
}
static int set_temp_data_on_rdfile(DMCPrivatePtr priv,int calib_point,int ofs,unsigned int a[][2])
{
int i;
unsigned int temp[16][2];
	memcpy(temp,a,sizeof(temp));
	switch( calib_point )
	{
	case	2:
		// 0  -  -2    -> 0  1  2
		// -  -  -     -> 3  4  5
		// -3 -  1     -> 6  7  8
		temp[2][0] = temp[1][0];
		temp[2][1] = temp[0][1];
		temp[3][0] = temp[0][0];
		temp[3][1] = temp[1][1];
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[2]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[2],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[3]);
		caldif(&priv->calib_temp_data[4][ofs],temp[0],temp[1]);
		caldif(&priv->calib_temp_data[5][ofs],temp[2],temp[1]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[3],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[3],temp[1]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[1],sizeof(int)*2);
		break;
	case	3:
		// 0  -  -3    -> 0  1  2
		// -  1  -     -> 3  4  5
		// -4 -  2     -> 6  7  8
		temp[3][0] = temp[2][0];
		temp[3][1] = temp[0][1];
		temp[4][0] = temp[0][0];
		temp[4][1] = temp[2][1];
#if CALIB_PAT_A
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[1][ofs],temp[1],temp[0]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[3],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[3][ofs],temp[4],temp[1]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[1],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[5][ofs],temp[3],temp[1]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[4],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[7][ofs],temp[1],temp[4]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[2],sizeof(int)*2);
#else
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[3]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[3],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[4]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[1],sizeof(int)*2);
		caldif(&priv->calib_temp_data[5][ofs],temp[2],temp[3]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[4],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[2],temp[4]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[2],sizeof(int)*2);
#endif
		break;
	case	4:
		// 0  -  1     -> 0  1  2
		// -  -  -     -> 3  4  5
		// 2  -  3     -> 6  7  8
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[1]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[1],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[2]);
		caldif(&priv->calib_temp_data[4][ofs],temp[0],temp[3]);
		caldif(&priv->calib_temp_data[5][ofs],temp[1],temp[3]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[2],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[2],temp[3]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[3],sizeof(int)*2);
		break;
	case	5:
		// 0  -  1     -> 0  1  2
		// -  2  -     -> 3  4  5
		// 3  -  4     -> 6  7  8
#if CALIB_PAT_A
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[1][ofs],temp[2],temp[0]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[1],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[3][ofs],temp[3],temp[2]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[2],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[5][ofs],temp[1],temp[2]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[3],sizeof(int)*2);
		aaacpy(&priv->calib_temp_data[7][ofs],temp[2],temp[3]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[4],sizeof(int)*2);
#else
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		caldif(&priv->calib_temp_data[1][ofs],temp[0],temp[1]);
		memcpy(&priv->calib_temp_data[2][ofs],temp[1],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[3]);
		memcpy(&priv->calib_temp_data[4][ofs],temp[2],sizeof(int)*2);
		caldif(&priv->calib_temp_data[5][ofs],temp[1],temp[4]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[3],sizeof(int)*2);
		caldif(&priv->calib_temp_data[7][ofs],temp[3],temp[4]);
		memcpy(&priv->calib_temp_data[8][ofs],temp[4],sizeof(int)*2);
#endif
		break;
	case	6:
		// 0  1  2     -> 0  1  2
		// -  -  -     -> 3  4  5
		// 3  4  5     -> 6  7  8
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[1][ofs],temp[1],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[2][ofs],temp[2],sizeof(int)*2);
		caldif(&priv->calib_temp_data[3][ofs],temp[0],temp[3]);
		caldif(&priv->calib_temp_data[4][ofs],temp[0],temp[5]);
		caldif(&priv->calib_temp_data[5][ofs],temp[2],temp[5]);
		memcpy(&priv->calib_temp_data[6][ofs],temp[3],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[7][ofs],temp[4],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[8][ofs],temp[5],sizeof(int)*2);
		break;
	case	9:
		// 0  1  2     -> 0  1  2
		// 3  4  5     -> 3  4  5
		// 6  7  8     -> 6  7  8
		memcpy(&priv->calib_temp_data[0][ofs],temp[0],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[1][ofs],temp[1],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[2][ofs],temp[2],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[3][ofs],temp[3],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[4][ofs],temp[4],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[5][ofs],temp[5],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[6][ofs],temp[6],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[7][ofs],temp[7],sizeof(int)*2);
		memcpy(&priv->calib_temp_data[8][ofs],temp[8],sizeof(int)*2);
		break;
	}
	return( 0 );
}
static void disp_calib_data(DMCPrivatePtr priv,char *s,unsigned int d[][4])
{
int i;
	for( i=0 ; i < MAX_CALIB_POINT ; i++ )
	{
		xf86Msg(0, "DMC(%d) : %s[%d]:Raw=%4d,%4d Adj=%4d,%4d \n"
						,priv->screen_num ,s ,i ,d[i][0] ,d[i][1] ,d[i][2] ,d[i][3]);
	}
}
static void aaacpy(u_int *d,u_int *a,u_int *b)
{
	d[0] = a[0];
	d[1] = b[1];
}
static void caldif(u_int *od,u_int *oa,u_int *ob)
{
int *a,*b,*d;
	d = (int *)od;
	a = (int *)oa;
	b = (int *)ob;
	if( a[0] > b[0] )
		d[0] = ((a[0] - b[0]) / 2) + b[0];
	else
		d[0] = ((b[0] - a[0]) / 2) + a[0];
	if( a[1] > b[1] )
		d[1] = ((a[1] - b[1]) / 2) + b[1];
	else
		d[1] = ((b[1] - a[1]) / 2) + a[1];
}
/********************************************* calibration function end ***/

static Bool init_dev(DMCPrivatePtr priv,Bool reinit)
{
int i;
	if( !priv->usb_dev )
		return( do_init_dev(priv,reinit) );
	for( i=0 ; i < 5 ; i++ )
	{
		if( do_init_dev(priv,reinit) )
			return(true);
	#ifndef XORG_OLDVERS
		if( !priv->modpath )
			break;
		xf86Msg(0, "DMC(%d) : init_dev retry %d \n",priv->screen_num ,i);
		xf86CloseSerial(priv->fd);
		insmod(priv);
		priv->fd = xf86OpenSerial(priv->pInfo->options);
		priv->pInfo->fd = priv->fd;
		usleep(500*1000);
	#endif
	}
	return(true);
}
static Bool do_init_dev(DMCPrivatePtr priv,Bool reinit)
{
	if( reinit && !priv->usb_dev )
	{
		xf86Msg(X_ERROR, "DMC(%d) : re-open\n",priv->screen_num );
		xf86CloseSerial(priv->fd);
		priv->fd = xf86OpenSerial(priv->pInfo->options);
		priv->pInfo->fd = priv->fd;
		sleep(1);
	}
	if( !tx_reset_goto_init(priv,true) )
	{
		if( !priv->usb_dev )
		{
#ifdef XORG_NEWVERS
			xf86Msg(X_ERROR, "DMC(%d) : reset err\n",priv->screen_num );
#else
			xf86Msg(X_ERROR, "DMC(%d) : reset err %d\n",priv->screen_num ,errno);
#endif
			return(false);
		}
		xf86Msg(X_ERROR, "DMC(%d) : not connect\n",priv->screen_num );
#ifndef XORG_NEWVERS
		usleep(100000);
#endif
		return(false);
	}
	else
	{
		usleep(500000); /* touch need ca. 500ms delay !!! */
		xf86Msg(0, "DMC(%d) : init ok\n",priv->screen_num);
		if( !tx_specify_goto_idle(priv,true) )
		{
			xf86Msg(X_ERROR, "DMC(%d) : specify\n",priv->screen_num );
			return(false);
		}
		else
		{
			xf86Msg(0, "DMC(%d) : specify(rate=%d) ok\n"
								,priv->screen_num,priv->samp_rate);
			if( tx_set_offdelay(priv,(u_short)priv->offdelay) == 0 )
				xf86Msg(0, "DMC(%d) : list-off-delay=%d ok\n"
								,priv->screen_num,priv->offdelay);
			switch( read_eeprom(priv) )
			{
			case	1:
				xf86Msg(0, "DMC(%d) : using EEPROM data\n",priv->screen_num );
				priv->eeprom_read_ok = true;
				break;
			case	0:
				xf86Msg(0, "DMC(%d) : not using EEPROM data\n",priv->screen_num );
				priv->eeprom_read_ok = true;
				break;
			default:
				xf86Msg(0, "DMC(%d) : no EEPROM\n",priv->screen_num );
				priv->eeprom_read_ok = false;
				break;
			}
			//
			goto_xyp(priv);
			xf86Msg(0, "DMC(%d) : found (OK)\n",priv->screen_num );
			if( priv->init_beep_on )
			{
#if XORG_NEWVERS14
				if( priv->consfd >= 0 )
					ioctl(priv->consfd,KDMKTONE,CONS_BEEP_VAL);
#else
				xf86SoundKbdBell(100,880,15);
#endif
			}
		}
	}
	return(true);
}
static int tx_set_mem(DMCPrivatePtr priv,u_short addr,u_short dat)
{
#if _3MEX2
	return(0);
#else
u_char cmd[] = { 0x19,0,0,0,0 };
int a[2];
	if( priv->usb_dev )
	{
		a[0] = addr;
		a[1] = dat;
		return( ioctl(priv->fd,USBDMC_WRITE_MEM,a) ); 
	}
	cmd[1] = (addr >> 8) & 0x0ff;
	cmd[2] = (addr & 0x0ff);
	cmd[3] = (dat >> 8) & 0x0ff;
	cmd[4] = (dat & 0x0ff);
	return( exec_cmd_send(priv,cmd,sizeof(cmd),true) );
#endif
	return(0);
}
static int tx_get_mem(DMCPrivatePtr priv,u_short addr)
{
#if _3MEX2
	return(0);
#else
u_char cmd[] = { 0x18,0,0 };
u_char s[10];
int a[2];
	//#if DEBUG_CMD
		xf86Msg(X_WARNING, "DMC(%d) : rdmem %d($%x)\n",priv->screen_num,addr,addr);
	//#endif
	if( priv->usb_dev )
	{
		a[0] = addr;
		if( ioctl(priv->fd,USBDMC_READ_MEM,a) == -1 )
			return(-1);
		return( a[0] );
	}
	XisbBlockDuration (priv->buffer, 500000);
	cmd[1] = (addr >> 8) & 0x0ff;
	cmd[2] = (addr & 0x0ff);
	if( DMCSendPacket(priv,cmd,sizeof(cmd)) != Success )
		return(-1);
	priv->lex_mode = DMC_Response0;
	if( DMCGetPacket(priv) != Success )
	{
		return(-1);
	}
	s[0] = priv->packet[0];
	priv->lex_mode = DMC_Response0;
	if( DMCGetPacket(priv) != Success )
	{
		xf86Msg(X_WARNING, "DMC(%d) : rdmem $%x Err\n",priv->screen_num,s[0]);
		return(-1);
	}
	s[1] = priv->packet[0];
	xf86Msg(X_WARNING, "DMC(%d) : rdmem $%x $%x\n",priv->screen_num,s[0],s[1]);
	return( ((s[0]<<8) + s[1]) & 0x0ffff );
#endif
}
static int tx_set_offdelay(DMCPrivatePtr priv,u_short dat)
{
#if _3MEX2
	return(0);
#else
int a[2];
	if( priv->usb_dev )
	{
		a[0] = (int)dat;
		return( ioctl(priv->fd,USBDMC_SET_OFFDELAY,a) ); 
	}
	return(0);
#endif
}
static int tx_get_offdelay(DMCPrivatePtr priv)
{
#if _3MEX2
	return(0);
#else
u_char s[10];
int a[2];
	if( priv->usb_dev )
	{
		if( ioctl(priv->fd,USBDMC_GET_OFFDELAY,a) == -1 )
			return(-1);
		return( a[0] );
	}
	return(0);
#endif
}
static Bool specify_set(DMCPrivatePtr priv)
{
int res,a;
DMCState st;
	st = priv->lex_mode;
	xf86FlushInput(priv->fd);
	priv->lex_mode = DMC_Response0;
	res = tx_reset_goto_init(priv,true);
	XisbBlockDuration (priv->buffer, -1);
	priv->lex_mode = st;
	return(res);
}
static Bool tx_reset_goto_init(DMCPrivatePtr priv,Bool wait_ack)
{
#if _3MEX2
	return(true);
#else
u_char reset[] = { RESET };
	if( priv->usb_dev )
		return( ((ioctl(priv->fd,USBDMC_RESET,0)) == -1 ? false : true) );
	return( exec_cmd_send(priv,reset,sizeof(reset),wait_ack) );
#endif
}
static Bool tx_specify_goto_idle(DMCPrivatePtr priv,Bool wait_ack)
{
#if _3MEX2
	return(true);
#else
u_char	specify[2] = { INI_2_IDLE, S_RATE };
int a;
	if( priv->usb_dev )
	{
		a = priv->samp_rate;
		return( ((ioctl(priv->fd,USBDMC_SPECIFY,&a)) == -1 ? false : true) );
	}
	specify[1] += (priv->samp_rate == RATE_PMODE ? 0x10 : priv->samp_rate);
	return( exec_cmd_send(priv,specify,sizeof(specify),wait_ack) );
#endif
}
static Bool tx_xyp_exit_goto_idle(DMCPrivatePtr priv,Bool wait_ack)
{
#if _3MEX2
	return(true);
#else
u_char to_idle[] = { XYP_2_IDLE };
	if( priv->usb_dev )
		return( ((ioctl(priv->fd,USBDMC_GOTO_IDLE,0)) == -1 ? false : true) );
	return( exec_cmd_send(priv,to_idle,sizeof(to_idle),wait_ack) );
#endif
}
static Bool goto_rom_read(DMCPrivatePtr priv)
{
#if _3MEX2
	return(false);
#else
u_char to_rom_read[] = { IDLE_2_RomRd };
	if( priv->usb_dev )
		return(true);
	return( exec_cmd_send(priv,to_rom_read,sizeof(to_rom_read),false) );
#endif
}
static Bool goto_xyp(DMCPrivatePtr priv)
{
#if _3MEX2
	return(true);
#else
u_char to_xyp[] = { IDLE_2_XYP };
	if( priv->usb_dev )
		return( ((ioctl(priv->fd,USBDMC_GOTO_XYP,0)) == -1 ? false : true) );
	return( exec_cmd_send(priv,to_xyp,sizeof(to_xyp),false) );
#endif
}
static Bool exec_cmd_send(DMCPrivatePtr priv,u_char s[],int len,Bool wait_ack)
{
int i;
	// ...............gott idle
	#if DEBUG_CMD
		xf86Msg(X_WARNING, "DMC(%d) : exec_cmd_send len=%d ",priv->screen_num,len);
		for( i=0 ; i < len ; i++ )
			xf86Msg(X_WARNING,"$%02X ",s[i]);
		xf86Msg(X_WARNING,"\n");
	#endif
	XisbBlockDuration (priv->buffer, -1);
	if( DMCSendPacket(priv,s,len) != Success )
		return(false);
	if( len >= 80 )
		XisbBlockDuration (priv->buffer, 10000000);
	else
		XisbBlockDuration (priv->buffer, 1000000);
		//XisbBlockDuration (priv->buffer, 500000);
	if( !wait_ack )
		return(true);
	priv->lex_mode = DMC_Response0;
	if( DMCGetPacket(priv) != Success )
	{
		#if DEBUG_CMD
			xf86Msg(X_WARNING, "DMC(%d) : None \n",priv->screen_num);
		#endif
		return(false);
	}
	if( priv->packet[0] == ACK )
	{
		#if DEBUG_CMD
			xf86Msg(X_WARNING, "DMC(%d) : cmd = $%x -> ACK \n",priv->screen_num,s[0]);
		#endif
		return(true);
	}
	if( DMCGetPacket(priv) == Success )
		xf86Msg(X_WARNING, "DMC(%d) : cmd = $%x -> NAK + $%x\n"
														,priv->screen_num,s[0],priv->packet[0]);
#if EEPROM_EMPTY_CHECK
	if( s[0] == INI_2_IDLE )
		return(true);
#endif
	return(false);
}
static Bool get_status(DMCPrivatePtr priv,char s[])
{
u_char stts[] = { 0x15 };
	// ...............gott idle
	#if DEBUG_CMD
		xf86Msg(X_WARNING, "DMC(%d) : get_status \n",priv->screen_num);
	#endif
	XisbBlockDuration (priv->buffer, 500000);
	if( DMCSendPacket(priv,stts,sizeof(stts)) != Success )
		return(false);
	priv->lex_mode = DMC_Response0;
	if( DMCGetPacket(priv) != Success )
	{
		return(false);
	}
	s[0] = priv->packet[0];
	priv->lex_mode = DMC_Response0;
	if( DMCGetPacket(priv) != Success )
	{
		xf86Msg(X_WARNING, "DMC(%d) : status $%x Err\n",priv->screen_num,s[0]);
		return(false);
	}
	s[1] = priv->packet[0];
	xf86Msg(X_WARNING, "DMC(%d) : status $%x $%x\n",priv->screen_num,s[0],s[1]);
	return(true);
}

static int read_eeprom(DMCPrivatePtr priv)
{
#if _3MEX2
	return(-1);
#else
int x,y,i,k,cnt,ofs;
int c;
u_short st;
u_char s[300];
	// ...............read EEPROM data
	#if DEBUG_PROM
		xf86Msg(X_WARNING, "DMC(%d) : read_eeprom s\n",priv->screen_num);
	#endif
	if( priv->usb_dev )
	{
		if( ioctl(priv->fd,USBDMC_READ_EEPROM,s) == -1 )
			return(-1);
	}
	else
	{
#if EEPROM_EMPTY_CHECK
		if( !get_status(priv,s) )
			return(-1);
		if( s[1]&0x80 )
			return(-1);
		if( !goto_rom_read(priv) )
			return(0);  /* eeprom empty */
#else
		if( !goto_rom_read(priv) )
			return(-1);
#endif
		XisbBlockDuration (priv->buffer, 500000);
		cnt = 2 + ((5 * 5) * 8) + 2 + 2;
		for( i=k=0 ; k < cnt ; i++ )
		{
			if( (c = XisbRead (priv->buffer)) >= 0 )
			{
				s[k++] = (u_char)c;
			}
			else
#if EEPROM_EMPTY_CHECK
				return(0);
#else
				return(-1);
#endif
		}
	}
	#if DEBUG_PROM
		xf86Msg(X_WARNING, "DMC(%d) : read_eeprom e\n",priv->screen_num);
		xf86Msg(X_WARNING, "DMC(%d) : read_eeprom %x %x %x %x %x %x\n",priv->screen_num,s[0],s[1],s[2],s[3],s[4],s[5]);
	#endif
	if( s[0] != 3 || s[1] != 3 )
		return(0);
	#if DEBUG_PROM
		xf86Msg(X_WARNING, "DMC(%d) : read_eeprom set 1\n",priv->screen_num);
	#endif
	adj_pkt_calib_dat(false,s,priv->max_x,priv->max_y);
	cnt = 2 + ((5 * 5) * 8);
	for( i=0,k=2 ; k < cnt && i < MAX_CALIB_POINT ; k+=2 )
	{
		ofs = ((k - 2) % 8) / 2;
		if( (((k-2)/8) % 5) < 3 )
		{
			//xf86Msg(X_WARNING, "DMC(%d) : read_eeprom %d $%x\n",priv->screen_num,k,((s[k]<<8)+s[k+1]));
			priv->calib_temp_data[i][ofs] = (s[k]*0x100) + s[k+1];
			if( ofs >= 3 )
				i++;
		}
	}
	k = cnt;
	x = (s[k]*0x100) + s[k+1];
	k+=2;
	y = (s[k]*0x100) + s[k+1];
	#if LOG_PROM_RD
		xf86Msg(0, "DMC(%d) : read_eeprom SCREEN %dx%d \n",priv->screen_num,x,y);
		disp_calib_data(priv,"read_eeprom",priv->calib_temp_data);
	#endif
	memcpy(priv->calib_data,priv->calib_temp_data,sizeof(priv->calib_data));
	priv->calib_point = MAX_CALIB_POINT;
	set_calib_area(priv,false);
	priv->calib_point = priv->file_data.point;
	return(1);
#endif
}
static Bool write_eeprom(DMCPrivatePtr priv)
{
#if _3MEX2
	return(false);
#else
Bool res;
int k;
u_char s[256];
Pkt_W_EEPROM *p;
	memset(s,0,sizeof(s));
	s[0] = IDEL_2_RomWr;
	p = (Pkt_W_EEPROM *)&s[1];
	p->x = 3;
	p->y = 3;
	set_1_pkt_calib_dat(&p->x00,priv->calib_data[0]);
	set_1_pkt_calib_dat(&p->x01,priv->calib_data[1]);
	set_1_pkt_calib_dat(&p->x02,priv->calib_data[2]);
	set_1_pkt_calib_dat(&p->x10,priv->calib_data[3]);
	set_1_pkt_calib_dat(&p->x11,priv->calib_data[4]);
	set_1_pkt_calib_dat(&p->x12,priv->calib_data[5]);
	set_1_pkt_calib_dat(&p->x20,priv->calib_data[6]);
	set_1_pkt_calib_dat(&p->x21,priv->calib_data[7]);
	set_1_pkt_calib_dat(&p->x22,priv->calib_data[8]);
	p->max_x = 1024-1;
	p->max_y = 768-1;
	cnv_lowhigh_calib_dat(true,p);
	k = sizeof(Pkt_W_EEPROM) + 1;
	if( priv->usb_dev )
	{
		res = ioctl(priv->fd,USBDMC_WRITE_EEPROM,p) == -1 ? false : true;
	}
	else
	{
		res = exec_cmd_send(priv,s,k,true);
	}
	asleep(priv,2);
	#if LOG_PROM_WR
		if( res )
			disp_calib_data(priv,"write_eeprom",priv->calib_data);
		else
			xf86Msg(0, "DMC(%d) : write_eeprom Error\n",priv->screen_num);
	#endif
	return( res );
#endif
}

static void set_1_pkt_calib_dat(Pkt_Calib *p,u_int dat[])
{
	p->rawx = (u_short)dat[0];
	p->rawy = (u_short)dat[1];
	p->refx = (u_short)dat[2];
	p->refy = (u_short)dat[3];
}
static void adj_pkt_calib_dat(Bool write_exec,void *top,int max_x,int max_y)
{
Pkt_W_EEPROM *wp;
Pkt_R_EEPROM *rp;
short wx,nmax_x,x0,fx,mx,ex,a;
short wy,nmax_y,y0,fy,my,ey;
char s[300];
	if( write_exec )
	{
		wp = (Pkt_W_EEPROM *)top;
		wx = max_x;
		wy = max_y;
		nmax_x = wp->max_x + 1;
		nmax_y = wp->max_y + 1;
		fx = wp->x00.refx;
		ex = nmax_x - fx;
		mx = nmax_x / 2;
		fy = wp->x00.refy;
		ey = nmax_y - fy;
		my = nmax_y / 2;
		wp->x00.refx = fx; wp->x00.refy = fy;
		wp->x01.refx = mx; wp->x01.refy = fy;
		wp->x02.refx = ex; wp->x02.refy = fy;
		wp->x10.refx = fx; wp->x10.refy = my;
		wp->x11.refx = mx; wp->x11.refy = my;
		wp->x12.refx = ex; wp->x12.refy = my;
		wp->x20.refx = fx; wp->x20.refy = ey;
		wp->x21.refx = mx; wp->x21.refy = ey;
		wp->x22.refx = ex; wp->x22.refy = ey;
		//x00
		adj_1_pkt_calib_dat(&wp->x00.rawx,false,&wp->x01.rawx,fx,wx,nmax_x);
		adj_1_pkt_calib_dat(&wp->x00.rawy,false,&wp->x10.rawy,fy,wy,nmax_y);
		//x01
		adj_1_pkt_calib_dat(&wp->x01.rawy,false,&wp->x11.rawy,fy,wy,nmax_y);
		//x02
		adj_1_pkt_calib_dat(&wp->x02.rawx,true ,&wp->x01.rawx,fx,wx,nmax_x);
		adj_1_pkt_calib_dat(&wp->x02.rawy,false,&wp->x12.rawy,fy,wy,nmax_y);
		//x10
		adj_1_pkt_calib_dat(&wp->x10.rawx,false,&wp->x11.rawx,fx,wx,nmax_x);
		//x11
		//x12
		adj_1_pkt_calib_dat(&wp->x12.rawx,true ,&wp->x11.rawx,fx,wx,nmax_x);
		//x20
		adj_1_pkt_calib_dat(&wp->x20.rawx,false,&wp->x21.rawx,fx,wx,nmax_x);
		adj_1_pkt_calib_dat(&wp->x20.rawy,true ,&wp->x10.rawy,fy,wy,nmax_y);
		//x21
		adj_1_pkt_calib_dat(&wp->x21.rawy,true ,&wp->x11.rawy,fy,wy,nmax_y);
		//x22
		adj_1_pkt_calib_dat(&wp->x22.rawx,true ,&wp->x21.rawx,fx,wx,nmax_x);
		adj_1_pkt_calib_dat(&wp->x22.rawy,true ,&wp->x12.rawy,fy,wy,nmax_y);
		//
		wp->max_x -= 1;
		wp->max_y -= 1;
	}
	else
	{
		memcpy(s,top,sizeof(Pkt_R_EEPROM));
		cnv_lowhigh_calib_dat(false,s);
		rp = (Pkt_R_EEPROM *)s;
		if( rp->max_x != (max_x-1) || rp->max_y != (max_y-1) )
		{
			wx = rp->max_x + 1;
			wy = rp->max_y + 1;
			nmax_x = max_x;
			nmax_y = max_y;
			fx = rp->x00.refx;
			ex = nmax_x - fx;
			mx = nmax_x / 2;
			fy = rp->x00.refy;
			ey = nmax_y - fy;
			my = nmax_y / 2;
			rp->x00.refx = fx; rp->x00.refy = fy;
			rp->x01.refx = mx; rp->x01.refy = fy;
			rp->x02.refx = ex; rp->x02.refy = fy;
			rp->x10.refx = fx; rp->x10.refy = my;
			rp->x11.refx = mx; rp->x11.refy = my;
			rp->x12.refx = ex; rp->x12.refy = my;
			rp->x20.refx = fx; rp->x20.refy = ey;
			rp->x21.refx = mx; rp->x21.refy = ey;
			rp->x22.refx = ex; rp->x22.refy = ey;
			//x00
			adj_1_pkt_calib_dat(&rp->x00.rawx,false,&rp->x01.rawx,fx,wx,nmax_x);
			adj_1_pkt_calib_dat(&rp->x00.rawy,false,&rp->x10.rawy,fy,wy,nmax_y);
			//x01
			adj_1_pkt_calib_dat(&rp->x01.rawy,false,&rp->x11.rawy,fy,wy,nmax_y);
			//x02
			adj_1_pkt_calib_dat(&rp->x02.rawx,true ,&rp->x01.rawx,fx,wx,nmax_x);
			adj_1_pkt_calib_dat(&rp->x02.rawy,false,&rp->x12.rawy,fy,wy,nmax_y);
			//x10
			adj_1_pkt_calib_dat(&rp->x10.rawx,false,&rp->x11.rawx,fx,wx,nmax_x);
			//x11
			//x12
			adj_1_pkt_calib_dat(&rp->x12.rawx,true ,&rp->x11.rawx,fx,wx,nmax_x);
			//x20
			adj_1_pkt_calib_dat(&rp->x20.rawx,false,&rp->x21.rawx,fx,wx,nmax_x);
			adj_1_pkt_calib_dat(&rp->x20.rawy,true ,&rp->x10.rawy,fy,wy,nmax_y);
			//x21
			adj_1_pkt_calib_dat(&rp->x21.rawy,true ,&rp->x11.rawy,fy,wy,nmax_y);
			//x22
			adj_1_pkt_calib_dat(&rp->x22.rawx,true ,&rp->x21.rawx,fx,wx,nmax_x);
			adj_1_pkt_calib_dat(&rp->x22.rawy,true ,&rp->x12.rawy,fy,wy,nmax_y);
			//
			rp->max_x = (short)nmax_x;
			rp->max_y = (short)nmax_y;
		}
		else
		{
			rp->max_x = (short)max_x;
			rp->max_y = (short)max_y;
		}
		cnv_lowhigh_calib_dat(false,s);
		memcpy(top,s,sizeof(Pkt_R_EEPROM));
	}

}
static void adj_1_pkt_calib_dat(u_short *st,int plus,u_short *ed
							,int def,u_short omax,u_short nmax)
{
float fraw,fref,fa,fdef;
	//
	fdef = def;
	if( plus )
		fraw = *st - *ed;
	else
		fraw = *ed - *st;
	fref = (omax - (fdef*2)) / 2;
	fa = ((fraw / fref) * omax);
	//
	fraw = fa / nmax;
	fref = (nmax - (fdef*2)) / 2;
	//
	if( plus )
		*st = *ed + (fref * fraw);
	else
		*st = *ed - (fref * fraw);
}
static void cnv_lowhigh_calib_dat(Bool write_exec,void *top)
{
Pkt_W_EEPROM *wp;
Pkt_R_EEPROM *rp;
	if( write_exec )
	{
		wp = (Pkt_W_EEPROM *)top;
		cnv_1_lowhigh_calib_dat(&wp->x00);
		cnv_1_lowhigh_calib_dat(&wp->x01);
		cnv_1_lowhigh_calib_dat(&wp->x02);
		cnv_1_lowhigh_calib_dat(&wp->x10);
		cnv_1_lowhigh_calib_dat(&wp->x11);
		cnv_1_lowhigh_calib_dat(&wp->x12);
		cnv_1_lowhigh_calib_dat(&wp->x20);
		cnv_1_lowhigh_calib_dat(&wp->x21);
		cnv_1_lowhigh_calib_dat(&wp->x22);
		wp->max_x = CONV_LOWHIGH(wp->max_x);
		wp->max_y = CONV_LOWHIGH(wp->max_y);
	}
	else
	{
		rp = (Pkt_R_EEPROM *)top;
		cnv_1_lowhigh_calib_dat(&rp->x00);
		cnv_1_lowhigh_calib_dat(&rp->x01);
		cnv_1_lowhigh_calib_dat(&rp->x02);
		cnv_1_lowhigh_calib_dat(&rp->x10);
		cnv_1_lowhigh_calib_dat(&rp->x11);
		cnv_1_lowhigh_calib_dat(&rp->x12);
		cnv_1_lowhigh_calib_dat(&rp->x20);
		cnv_1_lowhigh_calib_dat(&rp->x21);
		cnv_1_lowhigh_calib_dat(&rp->x22);
		rp->max_x = CONV_LOWHIGH(rp->max_x);
		rp->max_y = CONV_LOWHIGH(rp->max_y);
	}
}
static void cnv_1_lowhigh_calib_dat(Pkt_Calib *p)
{
	p->rawx = CONV_LOWHIGH(p->rawx);
	p->rawy = CONV_LOWHIGH(p->rawy);
	p->refx = CONV_LOWHIGH(p->refx);
	p->refy = CONV_LOWHIGH(p->refy);
}

static int asleep(DMCPrivatePtr priv,int sec)
{
int c;
	XisbBlockDuration (priv->buffer, sec*1000000);
	while ((c = XisbRead (priv->buffer)) >= 0)
	{
	#if 0
		xf86Msg(X_WARNING, "DMC(%d) : $%x\n",priv->screen_num,c);
	#endif
	}
}
static Bool read_save_file(DMCPrivatePtr priv)
{
	memset(priv->calib_temp_data,0,sizeof(priv->calib_temp_data));
	memset(priv->calib_data,0,sizeof(priv->calib_data));
	memset(&priv->file_data,0,sizeof(priv->file_data));
	if( !priv->save_file || !do_read_save_file(priv,&priv->file_data) )
	{
		priv->calib_point = 2;
		priv->tp_state = B_BELL_DOWN | B_BELL_UP;
		priv->samp_rate = 0;
		priv->offdelay = 0;
		xf86Msg(0, "DMC(%d) : don't open calib data file [%s]\n",priv->screen_num,priv->save_file);
		return(false);
	}
	priv->calib_point = priv->file_data.point;
	priv->tp_state = priv->file_data.tp_state;
	priv->samp_rate = priv->file_data.samp_rate;
	priv->offdelay = priv->file_data.offdelay;
	xf86Msg(0, "DMC(%d) : read - calib point %d\n",priv->screen_num,priv->calib_point);
	set_temp_data_on_rdfile(priv,priv->calib_point,0,priv->file_data.raw);
	set_temp_data_on_rdfile(priv,priv->calib_point,2,priv->file_data.adj);
	memcpy(priv->calib_data,priv->calib_temp_data,sizeof(priv->calib_data));
	adj_read_save_file(priv);
	disp_calib_data(priv,"Config",priv->calib_data);
	set_calib_area(priv,false);
	return(true);
}
static Bool do_read_save_file(DMCPrivatePtr priv,DMCSaveFile *file_data)
{
FILE *fp;
int i,dat;
u_int a,b;
char s[256],str[256];
	if( (fp = fopen(priv->save_file,"r")) == NULL )
		return(false);
	xf86Msg(0, "DMC(%d) : open calib data file [%s]\n",priv->screen_num,priv->save_file);
	for( i=0,file_data->point=0 ; ; )
	{
		if( fread(&s[i],1,1,fp) <= 0 )
			break;
		if( s[i] < ' ' )
		{
			if( i == 0 || s[0] == '#' )
			{
				i = 0;
				continue;
			}
			s[i] = 0;
			i = 0;
			if( sscanf(s,"%s %d",str,&dat) != 2 )
				break;
			switch( get_cfg_calib_str(str,&a,&b) )
			{
			case	0:	file_data->raw[a][b] = dat;	file_data->point++;			break;
			case	1:	file_data->adj[a][b] = dat;								break;
			case	2:	file_data->tp_state |= (dat == 1 ? B_BELL_DOWN : 0);	break;
			case	3:	file_data->tp_state |= (dat == 1 ? B_BELL_UP : 0);		break;
			case	4:	file_data->samp_rate = dat;								break;
			case	5:	file_data->offdelay = dat;								break;
			default:															break;
			}
		}
		else
		{
			i++;
			if( i >= sizeof(s) )
				i = 0;
		}
	}
	file_data->point /= 2;
	fclose(fp);
	return(true);
}
static int get_cfg_calib_str(char *str,unsigned int *a,unsigned int *b)
{
int i,k;
	for( i=0 ; cfgrawstr[i] ; i++ )
	{
		if( StrCmp(str,cfgrawstr[i]) == 0 )
		{
			*a = (i / 2);
			*b = (i % 2);
			return(0);
		}
	}
	for( i=0 ; cfgcalstr[i] ; i++ )
	{
		if( StrCmp(str,cfgcalstr[i]) == 0 )
		{
			*a = (i / 2);
			*b = (i % 2);
			return(1);
		}
	}
	for( i=0 ; cfgetcstr[i] ; i++ )
	{
		if( StrCmp(str,cfgetcstr[i]) == 0 )
			return( 2 + i );
	}
	return(-1);
}
static Bool write_save_file(DMCPrivatePtr priv,Bool no_calib)
{
FILE *fp;
int i;
	if( !priv->save_file || (fp = fopen(priv->save_file,"w")) == NULL )
	{
		xf86Msg(0, "DMC(%d) : don't save calib data file [%s]\n",priv->screen_num,priv->save_file);
		return(false);
	}
	xf86Msg(0, "DMC(%d) : save calib data file [%s]\n",priv->screen_num,priv->save_file);
	fprintf(fp,"# ------------------------- \n");
	fprintf(fp,"# DMC Touch-Panel Setup\n");
	fprintf(fp,"# ------------------------- \n");
	fprintf(fp,"%s %4d\n",cfgetcstr[0],(priv->tp_state & B_BELL_DOWN ? 1 : 0));
	fprintf(fp,"%s %4d\n",cfgetcstr[1],(priv->tp_state & B_BELL_UP ? 1 : 0));
	fprintf(fp,"%s %4d\n",cfgetcstr[2],priv->samp_rate);
	fprintf(fp,"%s %4d\n",cfgetcstr[3],priv->offdelay);
	fprintf(fp,"# ------------------------- \n");
	fprintf(fp,"# raw data\n");
	fprintf(fp,"# ------------------------- \n");
	if( no_calib && priv->file_data.point != 0 )
	{
		for( i=0 ; i < priv->file_data.point ; i++ )
		{
			fprintf(fp,"%s %4d\n",cfgrawstr[(i*2)+0],priv->file_data.raw[i][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(i*2)+1],priv->file_data.raw[i][1]);
		}
	}
	else
	{
		adj_write_save_file(priv);
		switch( priv->calib_point )
		{
		case	2:
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+0],priv->calib_data[0][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+1],priv->calib_data[0][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+0],priv->calib_data[8][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+1],priv->calib_data[8][1]);
			break;
		case	3:
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+0],priv->calib_data[0][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+1],priv->calib_data[0][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+0],priv->calib_data[4][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+1],priv->calib_data[4][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+0],priv->calib_data[8][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+1],priv->calib_data[8][1]);
			break;
		case	4:
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+0],priv->calib_data[0][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+1],priv->calib_data[0][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+0],priv->calib_data[2][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+1],priv->calib_data[2][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+0],priv->calib_data[6][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+1],priv->calib_data[6][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(3*2)+0],priv->calib_data[8][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(3*2)+1],priv->calib_data[8][1]);
			break;
		case	5:
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+0],priv->calib_data[0][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+1],priv->calib_data[0][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+0],priv->calib_data[2][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+1],priv->calib_data[2][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+0],priv->calib_data[4][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+1],priv->calib_data[4][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(3*2)+0],priv->calib_data[6][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(3*2)+1],priv->calib_data[6][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(4*2)+0],priv->calib_data[8][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(4*2)+1],priv->calib_data[8][1]);
			break;
		case	6:
			break;
		case	9:
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+0],priv->calib_data[0][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(0*2)+1],priv->calib_data[0][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+0],priv->calib_data[1][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(1*2)+1],priv->calib_data[1][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+0],priv->calib_data[2][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(2*2)+1],priv->calib_data[2][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(3*2)+0],priv->calib_data[3][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(3*2)+1],priv->calib_data[3][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(4*2)+0],priv->calib_data[4][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(4*2)+1],priv->calib_data[4][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(5*2)+0],priv->calib_data[5][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(5*2)+1],priv->calib_data[5][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(6*2)+0],priv->calib_data[6][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(6*2)+1],priv->calib_data[6][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(7*2)+0],priv->calib_data[7][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(7*2)+1],priv->calib_data[7][1]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(8*2)+0],priv->calib_data[8][0]);
			fprintf(fp,"%s %4d\n",cfgrawstr[(8*2)+1],priv->calib_data[8][1]);
			break;
		}
	}
	fprintf(fp,"# ------------------------- \n");
	fprintf(fp,"# calibration data\n");
	fprintf(fp,"# ------------------------- \n");
	if( no_calib && priv->file_data.point != 0 )
	{
		for( i=0 ; i < priv->file_data.point ; i++ )
		{
			fprintf(fp,"%s %4d\n",cfgcalstr[(i*2)+0],priv->file_data.adj[i][0]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(i*2)+1],priv->file_data.adj[i][1]);
		}
	}
	else
	{
		switch( priv->calib_point )
		{
		case	2:
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+0],priv->calib_data[0][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+1],priv->calib_data[0][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+0],priv->calib_data[8][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+1],priv->calib_data[8][3]);
			break;
		case	3:
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+0],priv->calib_data[0][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+1],priv->calib_data[0][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+0],priv->calib_data[4][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+1],priv->calib_data[4][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+0],priv->calib_data[8][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+1],priv->calib_data[8][3]);
			break;
		case	4:
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+0],priv->calib_data[0][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+1],priv->calib_data[0][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+0],priv->calib_data[2][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+1],priv->calib_data[2][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+0],priv->calib_data[6][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+1],priv->calib_data[6][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(3*2)+0],priv->calib_data[8][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(3*2)+1],priv->calib_data[8][3]);
			break;
		case	5:
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+0],priv->calib_data[0][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+1],priv->calib_data[0][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+0],priv->calib_data[2][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+1],priv->calib_data[2][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+0],priv->calib_data[4][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+1],priv->calib_data[4][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(3*2)+0],priv->calib_data[6][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(3*2)+1],priv->calib_data[6][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(4*2)+0],priv->calib_data[8][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(4*2)+1],priv->calib_data[8][3]);
			break;
		case	6:
			break;
		case	9:
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+0],priv->calib_data[0][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(0*2)+1],priv->calib_data[0][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+0],priv->calib_data[1][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(1*2)+1],priv->calib_data[1][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+0],priv->calib_data[2][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(2*2)+1],priv->calib_data[2][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(3*2)+0],priv->calib_data[3][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(3*2)+1],priv->calib_data[3][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(4*2)+0],priv->calib_data[4][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(4*2)+1],priv->calib_data[4][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(5*2)+0],priv->calib_data[5][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(5*2)+1],priv->calib_data[5][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(6*2)+0],priv->calib_data[6][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(6*2)+1],priv->calib_data[6][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(7*2)+0],priv->calib_data[7][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(7*2)+1],priv->calib_data[7][3]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(8*2)+0],priv->calib_data[8][2]);
			fprintf(fp,"%s %4d\n",cfgcalstr[(8*2)+1],priv->calib_data[8][3]);
			break;
		}
	}
	if( !no_calib )
		priv->file_data.point = 0;
	fclose(fp);
	return(true);
}
static int StrCmp(char *s1,char *s2)
{
int i;
	for( i=0 ; s1[i] && s2[i] ; i++ )
	{
		if( toupper(s1[i]) != toupper(s2[i]) )
			break;
	}
	if( s1[i] == 0 && s2[i] == 0 )
		return(0);
	return(-1);
}
static void aadump(char *msg,char *p,int len)
{
int i,k,pt;
unsigned char *pp;
char s[256];
	pp = (unsigned char *)p;
	for( i=0 ; i < len ; )
	{
		pt = sprintf(s,"%s:%04x : ",msg,i);
		for( k=0 ; i < len && k < 16 ; k++,i++ )
			pt += sprintf(&s[pt],"%02x ",pp[i]);
		xf86Msg(0, "DMC : %s\n",s);
	}
}
static void adj_read_save_file(DMCPrivatePtr priv)
{
int k,i,cnt,ofs;
u_char s[256];
Pkt_R_EEPROM *p;
	memset(s,0,sizeof(s));
	p = (Pkt_R_EEPROM *)s;
	p->x = 3;
	p->y = 3;
	set_1_pkt_calib_dat(&p->x00,priv->calib_data[0]);
	set_1_pkt_calib_dat(&p->x01,priv->calib_data[1]);
	set_1_pkt_calib_dat(&p->x02,priv->calib_data[2]);
	set_1_pkt_calib_dat(&p->x10,priv->calib_data[3]);
	set_1_pkt_calib_dat(&p->x11,priv->calib_data[4]);
	set_1_pkt_calib_dat(&p->x12,priv->calib_data[5]);
	set_1_pkt_calib_dat(&p->x20,priv->calib_data[6]);
	set_1_pkt_calib_dat(&p->x21,priv->calib_data[7]);
	set_1_pkt_calib_dat(&p->x22,priv->calib_data[8]);
	p->max_x = 1024 - 1;
	p->max_y = 768 - 1;
	cnv_lowhigh_calib_dat(false,s);
	adj_pkt_calib_dat(false,s,priv->max_x,priv->max_y);
	cnv_lowhigh_calib_dat(false,s);
	cnt = 2 + ((5 * 5) * 8);
	for( i=0,k=2 ; k < cnt && i < MAX_CALIB_POINT ; k+=2 )
	{
		ofs = ((k-2) % 8) / 2;
		if( (((k-2)/8) % 5) < 3 )
		{
			priv->calib_data[i][ofs] = (s[k+1]*0x100) + s[k];
			if( ofs >= 3 )
				i++;
		}
	}
}
static void adj_write_save_file(DMCPrivatePtr priv)
{
int k,i,cnt,ofs;
u_char s[256];
Pkt_W_EEPROM *p;
	memset(s,0,sizeof(s));
	p = (Pkt_W_EEPROM *)s;
	p->x = 3;
	p->y = 3;
	set_1_pkt_calib_dat(&p->x00,priv->calib_data[0]);
	set_1_pkt_calib_dat(&p->x01,priv->calib_data[1]);
	set_1_pkt_calib_dat(&p->x02,priv->calib_data[2]);
	set_1_pkt_calib_dat(&p->x10,priv->calib_data[3]);
	set_1_pkt_calib_dat(&p->x11,priv->calib_data[4]);
	set_1_pkt_calib_dat(&p->x12,priv->calib_data[5]);
	set_1_pkt_calib_dat(&p->x20,priv->calib_data[6]);
	set_1_pkt_calib_dat(&p->x21,priv->calib_data[7]);
	set_1_pkt_calib_dat(&p->x22,priv->calib_data[8]);
	p->max_x = 1024 - 1;
	p->max_y = 768 - 1;
	adj_pkt_calib_dat(true,p,priv->max_x,priv->max_y);
	cnt = 2 + ((3 * 3) * 8);
	for( i=0,k=2 ; k < cnt && i < MAX_CALIB_POINT ; k+=2 )
	{
		ofs = ((k-2) % 8) / 2;
		if( (((k-2)/8) % 3) < 3 )
		{
			priv->calib_data[i][ofs] = (s[k+1]*0x100) + s[k];
			if( ofs >= 3 )
				i++;
		}
	}
}
static NTIME get_time()
{
#if 1
NTIME t;
unsigned long a,b;	/* change INT32 -> unsigned long(for 64bit linux) */
#if GET_ABI_MAJOR(ABI_XINPUT_VERSION) < 3
	xf86getsecs(&a,&b);
#else
struct timeval aa;
	gettimeofday(&aa,0);
	a = aa.tv_sec;
	b = aa.tv_usec;
#endif
	t = a;
	t = (t * 1000) + (b / 1000);
	//xf86Msg(0, "DMC : time %qd (%d:%d)\n",t,a,b);
	return(t);
#else
NTIME t;
xf86TsRec a;
xf86TsPtr p[1];
	p[0] = &a;
	xf86Msg(0, "DMC : aaaa\n");
	xf86STimestamp(p);
	t = a.sec;
	t = (t * 1000) + (a.usec / 1000);
	//xf86Msg(0, "DMC : time %qd (%d:%d)\n",t,a.sec,a.usec);
	return(t);
#endif
}
static int diff_time(NTIME t2,NTIME t1)
{
	//xf86Msg(0, "DMC : diff %qd - %qd = %d \n",t2,t1,t2-t1);
	return( (int)t2-t1 );
}
#ifndef XORG_NEWVERS
static void test(void)
{
int i,k,fd;
char s[100];
	return;
xf86Msg(0, "DMC : fifo s\n");
	fd = open("/home/honda/abc",O_RDONLY);
	if( fd > 0 )
	{
		xf86Msg(0, "DMC : fifo open %d\n",fd);
		if( (k = read(fd,s,100)) > 0 )
			xf86Msg(0, "DMC : fifo r [%s] \n",s);
		else
			xf86Msg(0, "DMC : fifo r none \n");
		close(fd);
	}
xf86Msg(0, "DMC : fifo e \n");
}
#endif
#if CHG_SCR_RESOLUTION
static void adj_chg_resolution(DMCPrivatePtr priv)
{
int k,i,cnt,ofs;
u_char s[256];
Pkt_R_EEPROM *p;
	if( priv->reporting_mode == TS_Raw )
		return;
	xf86Msg(X_WARNING, "DMC(%d) change scr-reslution (%d,%d)->(%d,%d)\n"
			,priv->screen_num
			,priv->screen_width
			,priv->screen_height
			,screenInfo.screens[priv->screen_num]->width 
			,screenInfo.screens[priv->screen_num]->height );
	memset(s,0,sizeof(s));
	p = (Pkt_R_EEPROM *)s;
	p->x = 3;
	p->y = 3;
	set_1_pkt_calib_dat(&p->x00,priv->calib_data[0]);
	set_1_pkt_calib_dat(&p->x01,priv->calib_data[1]);
	set_1_pkt_calib_dat(&p->x02,priv->calib_data[2]);
	set_1_pkt_calib_dat(&p->x10,priv->calib_data[3]);
	set_1_pkt_calib_dat(&p->x11,priv->calib_data[4]);
	set_1_pkt_calib_dat(&p->x12,priv->calib_data[5]);
	set_1_pkt_calib_dat(&p->x20,priv->calib_data[6]);
	set_1_pkt_calib_dat(&p->x21,priv->calib_data[7]);
	set_1_pkt_calib_dat(&p->x22,priv->calib_data[8]);
	p->max_x = priv->max_x - 1;
	p->max_y = priv->max_y - 1;
	cnv_lowhigh_calib_dat(false,s);
	adj_pkt_calib_dat(false,s,screenInfo.screens[priv->screen_num]->width
				,screenInfo.screens[priv->screen_num]->height);
	cnv_lowhigh_calib_dat(false,s);
	cnt = 2 + ((5 * 5) * 8);
	for( i=0,k=2 ; k < cnt && i < MAX_CALIB_POINT ; k+=2 )
	{
		ofs = ((k-2) % 8) / 2;
		if( (((k-2)/8) % 5) < 3 )
		{
			priv->calib_data[i][ofs] = (s[k+1]*0x100) + s[k];
			if( ofs >= 3 )
				i++;
		}
	}
	priv->max_x = priv->screen_width
				= screenInfo.screens[priv->screen_num]->width;
	priv->max_y = priv->screen_height
				= screenInfo.screens[priv->screen_num]->height;
	disp_calib_data(priv,"Change",priv->calib_data);
	set_calib_area(priv,false);
}
#endif
#if ADJ_CALIB_DEFSCR
static void adj_temp_data_on_defscr(DMCPrivatePtr priv)
{
int k,i,cnt,ofs;
u_char s[256];
Pkt_R_EEPROM *p;
	xf86Msg(X_WARNING, "DMC(%d) adjust scr def=(%d,%d) now=(%d,%d)\n"
			,priv->screen_num
			,priv->screen_width
			,priv->screen_height
			,screenInfo.screens[priv->screen_num]->width 
			,screenInfo.screens[priv->screen_num]->height );
	memset(s,0,sizeof(s));
	p = (Pkt_R_EEPROM *)s;
	p->x = 3;
	p->y = 3;
	set_1_pkt_calib_dat(&p->x00,priv->calib_temp_data[0]);
	set_1_pkt_calib_dat(&p->x01,priv->calib_temp_data[1]);
	set_1_pkt_calib_dat(&p->x02,priv->calib_temp_data[2]);
	set_1_pkt_calib_dat(&p->x10,priv->calib_temp_data[3]);
	set_1_pkt_calib_dat(&p->x11,priv->calib_temp_data[4]);
	set_1_pkt_calib_dat(&p->x12,priv->calib_temp_data[5]);
	set_1_pkt_calib_dat(&p->x20,priv->calib_temp_data[6]);
	set_1_pkt_calib_dat(&p->x21,priv->calib_temp_data[7]);
	set_1_pkt_calib_dat(&p->x22,priv->calib_temp_data[8]);
	p->max_x = screenInfo.screens[priv->screen_num]->width - 1;
	p->max_y = screenInfo.screens[priv->screen_num]->height - 1;
	cnv_lowhigh_calib_dat(false,s);
	adj_pkt_calib_dat(false,s,priv->max_x,priv->max_y);
	cnv_lowhigh_calib_dat(false,s);
	cnt = 2 + ((5 * 5) * 8);
	for( i=0,k=2 ; k < cnt && i < MAX_CALIB_POINT ; k+=2 )
	{
		ofs = ((k-2) % 8) / 2;
		if( (((k-2)/8) % 5) < 3 )
		{
			priv->calib_temp_data[i][ofs] = (s[k+1]*0x100) + s[k];
			if( ofs >= 3 )
				i++;
		}
	}
}
#endif
#ifndef XORG_OLDVERS
void insmod(DMCPrivatePtr priv)
{
char s[256];
int res;
	if( !priv->usb_dev )
		return;
	//xf86Msg(X_WARNING, "DMC(%d) mod=[%x] \n",priv->screen_num,priv->modpath);
	if( !priv->modpath )
		return;
	sprintf(s,"/sbin/rmmod %s >/dev/null",priv->modpath);
	res = system(s);
	xf86Msg(X_WARNING, "DMC(%d) [%s] res=%d\n",priv->screen_num,s,res);
	sprintf(s,"/sbin/insmod %s >/dev/null",priv->modpath);
	res = system(s);
	xf86Msg(X_WARNING, "DMC(%d) [%s] res=%d\n",priv->screen_num,s,res);
}
#endif

